/*
Mindscape
Facciolo Boss Fight
	by Anonymous Coder

beta
*/

local FU = FRACUNIT

local function F_MobjUltimateRecolor(mo, color, var1)
	if Silverhorn.UltimateMode()
	and mo and mo.valid
		mo.colorized = var1
		mo.color = color
	end
end

freeslot(
	-- Sounds
	"sfx_bmeter", -- meter part
	"sfx_facbrr", -- barrier
	"sfx_facfcg", -- fireball charge
	"sfx_facfdh", -- fireball death
	"sfx_facflt", -- facc float
	"sfx_facftl", -- fireball trail
	"sfx_facfts", -- fireball toss
	"sfx_faclfr", -- laser fire
	"sfx_faclch", -- laser crash
	"sfx_facret", -- laser reticle
	"sfx_facflm", -- flamethrower
	"sfx_facsls", -- sword beam
	"sfx_facswd", -- sword swing
	"sfx_facwrp", -- teleport
	"sfx_facdsh", -- dash
	"sfx_facslm", -- slam
	"sfx_facmov", -- move
	"sfx_portop", -- open portal
	"sfx_portcl", -- close portal
	"sfx_dbchrg", -- charge
	"sfx_dbfire", -- meteo firing
	"sfx_dbmove", -- meteo moving
	"sfx_dbboom", -- meteo boom
	"sfx_dmdcol", -- d-m vocal
	"sfx_chrg1", -- tdx 1
	"sfx_chrg2", -- tdx 2
	"sfx_chrg3", -- tdx 3
	"sfx_chrg4", -- tdx 4
	"sfx_kboom1", -- kaboom small
	"sfx_fahit1",
	"sfx_fahit2",
	"sfx_fahit3",
	"sfx_fahit4",
	"sfx_fahit5",
	"sfx_fahit6",
	"sfx_fahit7",
	"sfx_fahit8",
	-- Boss Sprites
	"SPR_FACC", -- Facciolo
	"SPR_MNRV", -- Moonreaver
	-- Effect Sprites
	"SPR_BBEM",
	"SPR_FFBL",
	"SPR_FABF",
	"SPR_FABB",
	"SPR_FABO",
	"SPR_FALZ",
	"SPR_FDBE",
	"SPR_FFLF",
	"SPR_FMFQ",
	"SPR_AUR_", -- aura
	"SPR_SWD_", -- sword beam
	"SPR_ALC_", -- alert
	"SPR_FTHK", -- copy of thok for silverhorn alt 1 (do not apply models to this please)
	"SPR_THK_", -- center thok alt 2
	"SPR_WTHK", -- thok alt 3
	-- Boss States
	"S_FACCIOLO_IDLE",
	"S_FACCIOLO_PREP",
	"S_FACCIOLO_FIRETOSS1",
	"S_FACCIOLO_FIRETOSS2",
	"S_FACCIOLO_FIRETOSS3",
	"S_FACCIOLO_REFIRE",
	"S_FACCIOLO_HIT",
	"S_FACCIOLO_BARRIER",
	"S_FACCIOLO_FIREBALL",
	"S_FACCIOLO_FIREBALL_DEATH",
	"S_FACCIOLO_LASER",
	"S_FACCIOLO_LASER_SPAWN",
	"S_FACCIOLO_LASER_RETICLE",
	"S_FACCIOLO_LASER_FIRE",
	"S_FACCIOLO_DEATHBALL",
	"S_FACCIOLO_DEATHBALL_DEATH",
	"S_FACCIOLO_BARRIER_FORE",
	"S_FACCIOLO_BARRIER_BACK",
	"S_FACCIOLO_BARRIER_ORB",
	"S_FACCIOLO_FIRE",
	"S_FACCIOLO2_INTO",
	"S_FACCIOLO2_IDLE",
	"S_FACCIOLO2_HIT",
	"S_FACCIOLO2_AURA",
	"S_FACCIOLO2_SWORDBEAM",
	"S_FACCIOLO2_SWORDG",
	"S_FACCIOLO2_SPACEPORTAL",
	"S_FACCIOLO2_BIGALERT",
	"S_FACCIOLO2_BLACKHOLE_CHARGE",
	"S_FACCIOLO2_BLACKHOLE_PULL",
	"MT_FACCIOLO_BOSS",
	"MT_FACCIOLO_FIREBALL",
	"MT_FACCIOLO_LASER_RETICLE",
	"MT_FACCIOLO_LASER_SPAWN",
	"MT_FACCIOLO_LASER_FLASH",
	"MT_FACCIOLO_DEATHBALL",
	"MT_FACCIOLO_FIRE",
	"MT_FACCIOLO2_AURA",
	"MT_FACCIOLO2_SWORDBEAM_V",
	"MT_FACCIOLO2_SWORDG",
	"MT_FACCIOLO2_SPACEPORTAL",
	"MT_FACCIOLO2_ENERGYBALL",
	"MT_FACCIOLO2_BIGALERT",
	"MT_FACCIOLO2_BLACKHOLE"
)

local painsounds = {
	sfx_fahit1,
	sfx_fahit2,
	sfx_fahit3,
	sfx_fahit4,
	sfx_fahit5,
	sfx_fahit6,
	sfx_fahit7,
	sfx_fahit8
}

for i = 1, #painsounds
	sfxinfo[painsounds[i]].caption = "Facciolo Hurt"
	sfxinfo[painsounds[i]].flags = SF_X8AWAYSOUND
end

sfxinfo[sfx_facbrr].caption = "Barrier Explosion"
sfxinfo[sfx_facbrr].flags = SF_X8AWAYSOUND
sfxinfo[sfx_facfcg].caption = "Fireball Charge"
sfxinfo[sfx_facfcg].flags = SF_X8AWAYSOUND
sfxinfo[sfx_facfdh].caption = "Dissipation"
sfxinfo[sfx_facfdh].flags = SF_X2AWAYSOUND
sfxinfo[sfx_facflt].caption = "Floating"
sfxinfo[sfx_facflt].flags = SF_X2AWAYSOUND
sfxinfo[sfx_facftl].caption = "Fireball Trailing"
sfxinfo[sfx_facftl].flags = SF_X2AWAYSOUND|SF_NOMULTIPLESOUND
sfxinfo[sfx_facfts].caption = "Fireball Toss"
sfxinfo[sfx_facfts].flags = SF_X8AWAYSOUND
sfxinfo[sfx_faclfr].caption = "Laser Shot"
sfxinfo[sfx_faclfr].flags = SF_X8AWAYSOUND
sfxinfo[sfx_faclch].caption = "Laser Crash"
sfxinfo[sfx_faclch].flags = SF_X8AWAYSOUND
sfxinfo[sfx_facret].caption = "Reticle"
sfxinfo[sfx_facret].flags = SF_X8AWAYSOUND
sfxinfo[sfx_dbchrg].caption = "Energy Meteor Charge"
sfxinfo[sfx_dbchrg].flags = SF_X2AWAYSOUND|SF_X8AWAYSOUND
sfxinfo[sfx_dbchrg].caption = "Energy Meteor Fire"
sfxinfo[sfx_dbfire].flags = SF_X8AWAYSOUND
sfxinfo[sfx_dbmove].caption = "Energy Meteor Moving"
sfxinfo[sfx_dbmove].flags = SF_X2AWAYSOUND|SF_X8AWAYSOUND
sfxinfo[sfx_dbboom].caption = "Energy Meteor Exploding"
sfxinfo[sfx_dbboom].flags = SF_X8AWAYSOUND
sfxinfo[sfx_bmeter].caption = "Boss Meter"
sfxinfo[sfx_bmeter].singular = true
sfxinfo[sfx_kboom1].caption = "Small Ka-boom"

mobjinfo[MT_FACCIOLO_BOSS] = {
	doomednum = 2560,
	spawnstate = S_FACCIOLO_IDLE,
	painstate = S_FACCIOLO_HIT,
	deathstate = S_FACCIOLO_HIT,
	spawnhealth = 10000,
	radius = 31*FU,
	height = 105*FU,
	flags = MF_NOGRAVITY|MF_BOSS|MF_SPECIAL|MF_SHOOTABLE
}

mobjinfo[MT_FACCIOLO_FIREBALL] = {
	spawnstate = S_FACCIOLO_FIREBALL,
	deathstate = S_FACCIOLO_FIREBALL_DEATH,
	painsound = sfx_facfdh,
	spawnhealth = 1,
	radius = 15*FU,
	height = 30*FU,
	flags = MF_NOGRAVITY|MF_SPECIAL|MF_NOCLIPHEIGHT
}

mobjinfo[MT_FACCIOLO_DEATHBALL] = {
	spawnstate = S_FACCIOLO_DEATHBALL,
	deathstate = S_FACCIOLO_DEATHBALL_DEATH,
	spawnhealth = 1,
	radius = 64*FU,
	height = 118*FU,
	flags = MF_NOGRAVITY|MF_SPECIAL
}

mobjinfo[MT_FACCIOLO_LASER_RETICLE] = {
	spawnstate = S_FACCIOLO_LASER_RETICLE,
	deathstate = S_FACCIOLO_LASER_RETICLE,
	radius = FU,
	height = FU,
	flags = MF_NOGRAVITY
}

mobjinfo[MT_FACCIOLO_LASER_SPAWN] = {
	spawnstate = S_INVISIBLE,
	radius = 64*FU,
	height = FU,
	flags = MF_NOGRAVITY
}

mobjinfo[MT_FACCIOLO_LASER_FLASH] = {
	spawnstate = S_FACCIOLO_LASER_SPAWN,
	radius = FU,
	height = FU,
	flags = MF_NOGRAVITY
}

mobjinfo[MT_FACCIOLO_FIRE] = {
	spawnstate = S_FACCIOLO_FIRE,
	deathstate = S_NULL,
	radius = 10*FU,
	height = 50*FU,
	flags = MF_PAIN
}

mobjinfo[MT_FACCIOLO2_AURA] = {
	spawnstate = S_FACCIOLO2_AURA,
	deathstate = S_NULL,
	radius = 60*FU,
	height = 90*FU,
	flags = MF_NOGRAVITY
}

mobjinfo[MT_FACCIOLO2_SWORDBEAM_V] = {
	spawnstate = S_FACCIOLO2_SWORDBEAM,
	deathstate = S_FACCIOLO2_SWORDBEAM,
	speed = 40*FU,
	radius = 64*FU,
	height = 64*FU,
	activesound = sfx_facsls,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_MISSILE|MF_PAIN,
}

mobjinfo[MT_FACCIOLO2_SWORDG] = {
	spawnstate = S_FACCIOLO2_SWORDG,
	deathstate = S_FACCIOLO2_SWORDG,
	speed = 40*FU,
	radius = 64*FU,
	height = 96*FU,
	activesound = sfx_facsls,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_MISSILE|MF_PAIN,
}

mobjinfo[MT_FACCIOLO2_SPACEPORTAL] = {
	spawnstate = S_FACCIOLO2_SPACEPORTAL,
	radius = 64*FU,
	height = FU,
	flags = MF_NOGRAVITY
}

mobjinfo[MT_FACCIOLO2_ENERGYBALL] = {
	spawnstate = S_FACCIOLO_DEATHBALL,
	deathstate = S_FACCIOLO_DEATHBALL_DEATH,
	spawnhealth = 1,
	radius = 64*FU,
	height = 118*FU,
	activesound = sfx_dbmove,
	flags = MF_NOGRAVITY|MF_SPECIAL|MF_FIRE
}

mobjinfo[MT_FACCIOLO2_BIGALERT] = {
	spawnstate = S_FACCIOLO2_BIGALERT,
	spawnhealth = 1,
	radius = 32*FU,
	height = 1*FU,
	flags = MF_NOGRAVITY
}

mobjinfo[MT_FACCIOLO2_BLACKHOLE] = {
	spawnstate = S_FACCIOLO2_BLACKHOLE_CHARGE,
	spawnhealth = 1,
	radius = 1*FU,
	height = 1*FU,
	flags = MF_NOGRAVITY
}

local function SpacePortalThinker(mo)

	if not mo and mo.valid then return end

	if mo.facc then return end -- disables thinker

	if (leveltime % 10 == 0) then

		local afterimage = P_SpawnGhostMobj(mo)

		afterimage.fuse = 15
		afterimage.tics = 15
		afterimage.destscale = mo.scale+2*FU
		afterimage.spriteyoffset = -32*FU
		afterimage.colorized = true
		afterimage.renderflags = mo.renderflags
		afterimage.color = SKINCOLOR_MINT

		-- Clone arcane rush's effects
		if (mo.renderflags & RF_PAPERSPRITE) then
			P_InstaThrust(afterimage, mo.angle-ANGLE_90, 5*FU)
		elseif (mo.renderflags & RF_FLOORSPRITE) then
			afterimage.momz = (mo.facciolo) and -5*FU or 5*FU
		end
	end
end

freeslot("SPR_SWDG")
local function SwordBeamThink(mo, mtype)

	mo.blendmode = AST_ADD
	mo.renderflags = $|RF_FULLBRIGHT
	mo.color = SKINCOLOR_MAGENTA

	-- if mo.z <= mo.floorz then
	-- 	mo.momz = 0
	-- 	mo.sprite = SPR_NULL
	-- 	for i=-32, 32, 32 do
	-- 		local gwave = P_SpawnGhostMobj(mo)
	-- 		-- local gwave = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_FACCIOLO2_SWORDG)
	-- 		-- gwave.momx = mo.momx
	-- 		-- gwave.momy = mo.momy
	-- 		-- mo.momx = 0
	-- 		-- mo.momy = 0
	-- 		gwave.flags = $1|MF_PAIN
	-- 		gwave.state = S_FACCIOLO2_SWORDG
	-- 		gwave.color = SKINCOLOR_MAGENTA
	-- 		-- gwave.sprite = SPR_SWDG
	-- 		-- gwave.frame = $1|TR_TRANS10
	-- 		-- gwave.angle = mo.angle+ANG10
	-- 		gwave.angle = mo.angle + FixedAngle(i*FU)
	-- 		P_InstaThrust(gwave, gwave.angle, mo.momx)
	-- 		gwave.renderflags = RF_PAPERSPRITE
	-- 		gwave.blendmode = AST_ADD
	-- 		gwave.fuse = 1*TICRATE
	-- 		-- gwave.fuse = 20
	-- 		-- mo.fuse = 0
	-- 		-- P_RemoveMobj(mo)
	-- 	end
	-- else
		local trail = P_SpawnGhostMobj(mo)
		trail.mirrored = mo.mirrored
		trail.blendmode = AST_ADD
		trail.fuse = 20
	-- end

	-- unused
	if mtype then
		mo.angle = $1+ANG20
		mo.renderflags = $1|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
		mo.flags2 = $1|MF2_SPLAT
		trail.renderflags = $1|RF_FLOORSPRITE|RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
		trail.flags2 = $1|MF2_SPLAT
	end
end

local function SwordBeamFuse(mo)
	if mo.valid then
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
		P_RemoveMobj(mo)
	end
	return true
end

local function EnergyBallThinker(mo)

	if not mo and mo.valid then return end

	if (mo.health) then

		mo.spriteyoffset = -32*FU

		-- Explode on the floor
		if (mo.z <= mo.floorz) then
			P_DamageMobj(mo, nil, nil, 1)
			mo.state = mobjinfo[MT_FACCIOLO2_ENERGYBALL].deathstate
		end
		if not S_SoundPlaying(mo, mo.facciolo and mobjinfo[MT_FACCIOLO2_ENERGYBALL].activesound or sfx_facbrr) then
			S_StartSoundAtVolume(mo, mo.facciolo and mobjinfo[MT_FACCIOLO2_ENERGYBALL].activesound or sfx_facbrr, mo.facciolo and 255 or 150)
		end
		P_SpawnGhostMobj(mo)
		P_StartQuake(mo.scale, 15)
	end
end

local function EnergyBallDeath(mo)

	S_StartSoundAtVolume(nil, mo.facciolo and sfx_dbboom or sfx_facfdh, mo.facciolo and 255 or 40)
	P_StartQuake(mo.facciolo and 50*FU or mo.scale+4*FU, 35)

	-- if marked with his name, it's a special version
	if mo.facciolo then
		for i=0, 360, 2 do
			local explodefire = P_SpawnMobj(mo.x, mo.y, mo.z, MT_FACCIOLO_FIRE)
			explodefire.momx = P_RandomRange(-32, 32)*FU
			explodefire.momy = P_RandomRange(-32, 32)*FU
			explodefire.momz = 20*FU
			explodefire.scale =  P_RandomRange(3, 7)*FU
			explodefire.colorized = true
			explodefire.color = SKINCOLOR_KETCHUP
			explodefire.frame = $1|TR_TRANS50
			explodefire.blendmode = AST_ADD
			explodefire.fuse = P_RandomRange(4, 7)*TICRATE
		end

		for player in players.iterate do
			P_FlashPal(player, 1, 6)
		end

		-- Inazuma — Today at 4:49 AM
		-- i think it should. It would be really funny
		-- [4:49 AM]
		-- especially because its telegraphed
		-- [4:49 AM]
		-- its the most telegraphed attack
		-- [4:49 AM]
		-- if you die its your fault entirely
		searchBlockmap("objects", function(_, found)
			if (found.type == MT_PLAYER) then
				P_DamageMobj(found, nil, nil, 50, DMG_NUKE)
				-- P_KillMobj(found)
			end
		-- TODO: mark radius
		end, mo, mo.x - 1400*FU, mo.x + 1400*FU, mo.y - 1400*FU, mo.y + 1400*FU)
		-- end, mo, mo.x - FixedMul(25*FU, 56*FU), mo.x + FixedMul(25*FU, 56*FU), mo.y - FixedMul(25*FU, 56*FU), mo.y + FixedMul(25*FU, 56*FU))
	end
	-- Remove anything set as tracer
	if mo.tracer then P_RemoveMobj(mo.tracer) end
end

local function DarkholeThinker(mo)

	if not mo and mo.valid then return end

	if (mo.health) then
		if (leveltime % 8 == 0) then
			local pullwave = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			pullwave.sprite = SPR_THK_
			pullwave.tics = 4*TICRATE
			pullwave.renderflags = RF_FLOORSPRITE
			pullwave.blendmode = AST_SUBTRACT
			pullwave.scale = 32*FU
			pullwave.destscale = 0
			pullwave.scalespeed = FU --4*FU
			pullwave.momz = -32*FU
		end
		mo.scale = 1*FU + abs(4*cos(leveltime*FixedAngle(50*FU)))
		mo.blendmode = AST_SUBTRACT
	end

end

addHook("MobjThinker", SpacePortalThinker, MT_FACCIOLO2_SPACEPORTAL)

addHook("ShouldDamage", SpacePortalThinker, MT_FACCIOLO2_SPACEPORTAL)
addHook("MobjThinker", SwordBeamThink, MT_FACCIOLO2_SWORDBEAM_V)
addHook("MobjFuse", SwordBeamFuse, MT_FACCIOLO2_SWORDBEAM_V)
addHook("MobjThinker", EnergyBallThinker, MT_FACCIOLO2_ENERGYBALL)
addHook("MobjDeath", EnergyBallDeath, MT_FACCIOLO2_ENERGYBALL)
addHook("MobjThinker", DarkholeThinker, MT_FACCIOLO2_BLACKHOLE)


addHook("LinedefExecute", do
	//Find Facciolo in the level
	local mo
	local facc
	for mobj in mobjs.iterate()
		if mobj.type == MT_FACCIOLO_BOSS
		and mobj.facc
			mo = mobj
			facc = mobj.facc
			break
		end
	end
	if not (mo and facc) then return end

	//Start Phase 2 immediately if we already got to it this Mindscape session
	if MindscapeSessionFlags & MS_BEATPHASEONE then
		-- print("========Boss Action (facciolo_phase2)========")
		facc.active = 0
		facc.phase = 2
		facc.invincible = false
		EventSH.start("facciolo_phase2", {boss=mo})

	//Start Phase 1
	else
		//Activate Facciolo and start text
		facc.active = 1
		startmindtext(1000)

		// Change the music
		-- Note to Anonymous Coder: Do all this code for every phase!
		local music = Silverhorn.UltimateMode() and "PS1ULT" or "PHASE1"
		S_ChangeMusic(music, true, nil, 0, 0, 0, 3000)
		mapmusname = music
		if multiplayer
			mapmusflags = 0 // Don't reload music on death
		else
			mapmusflags = 32768 // 0x8000 Reload music on death
		end
	end
end, "FACCBOSSTRIGGER")

addHook("MobjSpawn", function(mo)
    --mo.z = 1000*FU
    mo.color = SKINCOLOR_SLATE
	F_MobjUltimateRecolor(mo, SKINCOLOR_AETHER, false)
    mo.facc = {
		ang1 = ANG1,
		ang2 = ANG1,
		statetimer = TICRATE*7,
		x = mo.x,
		y = mo.y,
		firsttime = true,
		laserchance = Silverhorn.UltimateMode() and 60 or 40,
		active = 0,
		phase = 1,
		health = 8,
		refire = 0,
		barrier = {},
		-- extras
		firsttime_truly = true,
		ph2_introover = false,
		isntseen = false,
		invincible = false,
		nulltarget = {},
		hittime = 0,
		valid = true,
    }
end, MT_FACCIOLO_BOSS)

local FACCIOLO_AURAS = {
{SKINCOLOR_MAGENTA,SKINCOLOR_PASTEL,SKINCOLOR_DUSK},
{SKINCOLOR_AQUA,SKINCOLOR_YELLOW,SKINCOLOR_RED}
}
addHook("MobjThinker", function(mo)
	if not mo and mo.valid then return end

	if (mo.tracer and mo.tracer.valid) then
		-- We had to move this because of invalid errors that happened 6 months after october 2021... (why?)

		local hasinvuln = (mo.tracer.facc and mo.tracer.facc.invincible == true)
		mo.sprite = hasinvuln and SPR_BBEM or SPR_AUR_

		if hasinvuln then
			-- un
			mo.spriteyoffset = FixedMul(-8*FU, mo.scale)
			mo.scale = max(5*FU, abs(7*cos(leveltime*ANG2)))/2
			mo.frame = $1|TR_TRANS10
			mo.colorized = true
		else
			mo.scale = max(5*FU, abs(7*cos(leveltime*ANG2)))
			mo.spriteyoffset = 0
			mo.blendmode = AST_ADD
			mo.colorized = false
		end
		-- mo.scale = 6*FU

		-- Prevent aura from drawing if its tracer is invisible
		if mo.tracer.flags2 & MF2_DONTDRAW then
			mo.flags2 = $1|MF2_DONTDRAW
			P_MoveOrigin(mo, mo.tracer.x, mo.tracer.y, mo.tracer.z)
		else
			local aura = FACCIOLO_AURAS[hasinvuln and 2 or 1]
			mo.color = aura[(leveltime/10 % #aura)+1]
			P_MoveOrigin(mo, mo.tracer.x, mo.tracer.y, mo.tracer.z)

			local ghost = P_SpawnGhostMobj(mo)
			ghost.fuse = $-2
			ghost.momz = $1+4*FU
			ghost.blendmode = AST_ADD
			ghost.spriteyoffset = hasinvuln and FixedMul(-8*FU, mo.scale) or 0
		end
	else
		mo.fuse = 10
	end
end, MT_FACCIOLO2_AURA)

addHook("MobjThinker", function(mo)

	if mo and mo.valid then

		local facc = mo.facc

		mo.scale = 2*FU

		-- Handle certain things for phases
		if (facc.phase == 1) then

			-- spawns facciolo's barrier
			facc.ang2 = $ + FixedAngle(4*FU)
			mo.z = $+4*sin(facc.ang2)
			if mo.state == S_FACCIOLO_HIT
			or mo.state == S_FACCIOLO_BARRIER then
				--mo.flags2 = $ | MF2_INVERTAIMABLE
				if mo.state != FACCIOLO_BARRIER
					mo.frame = (leveltime % 3 == 0) and (K|FF_FULLBRIGHT) or (L|FF_FULLBRIGHT)
				end
				local dist = R_PointToDist2(mo.x, mo.y, facc.x, facc.y)
				local ang = R_PointToAngle2(mo.x, mo.y, facc.x, facc.y)
				local radius = mo.radius/FU-7
				P_InstaThrust(mo, ang, dist/ (Silverhorn.UltimateMode() and 4 or 8))
				//mo.flags2 = $ &~ MF2_FRET
			else
				local ghost = P_SpawnGhostMobj(mo)
				P_MoveOrigin(ghost, mo.x-10*cos(mo.angle), mo.y-10*sin(mo.angle), mo.z)
				ghost.colorized = true
				ghost.color = SKINCOLOR_VAPOR
				F_MobjUltimateRecolor(ghost, SKINCOLOR_DUSK, true)
				ghost.momx = ghost.x-mo.x
				ghost.momy = ghost.y-mo.y
				ghost.momz = ghost.z-mo.z
				ghost.fuse = $ - 2 --less time to live
				mo.flags2 = $&~ MF2_INVERTAIMABLE
			end

			-- Barrier damages when it's active
			if facc.barrier and #facc.barrier
			and facc.barrier[1] and facc.barrier[1].valid
				P_RadiusAttack(mo, mo, FixedDiv(mo.radius*12, mo.scale), 0, false)
				if facc.barrier[1].tics <= 1
					mo.flags2 = $1 & ~MF2_FRET
				else
					mo.flags2 = $1 | MF2_FRET
				end
			end
		elseif (facc.phase == 2) then

			-- the game now breaks painstate on 1 end, so we have to forcibly let the game know intro is over :\
			if not facc.ph2_introover then return end

			-- Set sprite to fullbright
			mo.renderflags = $1|RF_FULLBRIGHT

			facc.hittime = max(0, $1-1)

			-- Change the painstate to a custom one
			if mo.state == S_FACCIOLO_HIT then mo.state = S_FACCIOLO2_HIT end

			-- Spawn aura
			if not mo.aura then
				mo.aura = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_FACCIOLO2_AURA)
				mo.aura.tracer = mo
			end

			--Do skincolor
			local color = Silverhorn.UltimateMode() and SKINCOLOR_SUPER_BLOODMOON1 or SKINCOLOR_SUPER_SHADOWMIST1
			mo.color = color + abs( ( (leveltime >> 1) % 9) - 4)

			-- NULLTARGET TEST
			-- if (mo.target and mo.target.type == facc.nulltarget.type) then
			-- 	mo.target.scale = 3*FU
			-- 	mo.target.sprite = SPR_EGGM
			-- end
		end
	end
end, MT_FACCIOLO_BOSS)

-- hitdisplay preset
HitDisplaySH.facciolo = function(newname, newmax, bossbase)
	return {
		ex = nil,
		basemobj = bossbase,
		identifier = nil,
		drawx = 320/2 + 32,
		drawy = 160/2 + 100,
		hp_drawx = 5,
		hp_drawy = 3,
		hpfill = "METER_PR",
		hphurt = "METER_OR",
		hpempty = "METERNON",
		hpempty_flags = TR_TRANS20,
		boxwidth = 102,
		boxheight = 1,
		maxhealth = newmax,
		enemyname = newname,
		enemyname_align = "right",
		name_drawx = 112,
		name_drawy = -10,
		border = "METERFAC",
		removeonempty = true,
		displaysound = sfx_bmeter,
		hurtref = "hittime",
	}
end

local function orbact(mo)
	if mo and mo.valid
	and mo.facciolo and mo.facciolo.valid
		if mo.state != mo.info.deathstate
			local facmo = mo.facciolo
			local facc = facmo.facc
			local radius = facmo.radius/FU-10
			local pmo = facmo.target
			local radius2 = mo.radius/FU
			if pmo and pmo.valid
				if pmo.player.playerstate == PST_LIVE
					local ang = R_PointToAngle2(mo.x, mo.y, pmo.x, pmo.y)
					local dist = R_PointToDist2(mo.x, mo.y, pmo.x, pmo.y)*3/2
					if Silverhorn.UltimateMode()
						dist = ($/3*2)*2
					end
					if mo.charging
						P_MoveOrigin(mo,
							facmo.x+radius*cos(facmo.angle-ANGLE_90)+5*cos(facmo.angle),
							facmo.y+radius*sin(facmo.angle-ANGLE_90)+5*sin(facmo.angle),
							facmo.z+facmo.height
						)
					else
						mo.angle = $ + FixedAngle(FU)
						mo.momz = ((mo.z - pmo.z)*2)/-16 + (2*sin(mo.angle))
						dist = (dist/10 <= 20*FU) and 20*FU or $/10
						P_InstaThrust(mo, ang, dist)
						if not S_SoundPlaying(mo, sfx_facftl)
							S_StartSound(mo, sfx_facftl)
						end
						if leveltime % 4 == 0
							local ang2 = -ang+FixedAngle(P_RandomRange(-22, 22)*FU)
							local fire = P_SpawnMobjFromMobj(mo, radius2*cos(ang2), radius2*sin(ang2), mo.height/2, MT_FACCIOLO_FIRE)
							fire.momz = FU*6
							fire.fuse = TICRATE*5
							F_MobjUltimateRecolor(fire, SKINCOLOR_FLAME, true)
						end
					end
				elseif mo.type == MT_FACCIOLO_FIREBALL
					P_KillMobj(mo)
				end
			end
		else
			mo.momz = 0
			mo.momx = 0
			mo.momy = 0
		end
	end
end

local function orbfuse(mo)
	P_KillMobj(mo)
	return true
end

addHook("MobjThinker", orbact, MT_FACCIOLO_FIREBALL)
addHook("MobjThinker", orbact, MT_FACCIOLO_DEATHBALL)

addHook("MobjThinker", function(mo)
	if mo and mo.valid
		local facmo = mo.facciolo
		if mo.fuse <= 5*TICRATE
			P_StartQuake(FU*5, 1)
			if not mo.laseractive
				local laser = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
				laser.state = S_FACCIOLO_LASER
				laser.fuse = (mo.laserph2 and 1*TICRATE or mo.fuse) + NUMTRANSMAPS -- ph2:adjustable laser fuse
				laser.facciolo = facmo

				laser.scale = FU
				laser.height = laser.scale

				laser.z = mo.floorz + 2*FU -- fix: offset by 2 units to try to stay out of deathpits
				laser.spriteyscale = abs(mo.floorz - mo.ceilingz)/64
				laser.spriteyoffset = $ - 4*FU

				F_MobjUltimateRecolor(laser, SKINCOLOR_FLAME, true)
				S_StartSoundAtVolume(laser, sfx_faclch, mo.laserloudness or 255) -- ph2:adjustable volume needed
				mo.laseractive = true
			end

			-- Damage!
			searchBlockmap("objects", function(_, found)
				if found == facmo
				or FixedHypot(found.x - mo.x, found.y - mo.y) > mo.radius
				or mo.floorz > found.z + found.height
				or mo.ceilingz < found.z
					return
				end

				-- ... I dont think this fixes laser damage
				if (mo.laserph2) then
					if mo.fuse >= 4*TICRATE then
						P_DamageMobj(found, mo, facmo or mo)
					end
				else
					P_DamageMobj(found, mo, facmo or mo)
				end
			end, mo, mo.x - 128*FU, mo.x + 128*FU, mo.y - 128*FU, mo.y + 128*FU)
		elseif not mo.tracer
			mo.tracer = P_SpawnMobjFromMobj(mo, 0,0,0, MT_FACCIOLO_LASER_RETICLE)
			mo.tracer.z = (facmo.target and facmo.target.valid) and facmo.target.z or $
			mo.tracer.colorized = true
			mo.tracer.color = SKINCOLOR_CYAN
			F_MobjUltimateRecolor(mo.tracer, SKINCOLOR_FLAME, true)
			mo.tracer.facciolo = facmo
			mo.tracer.fuse = TICRATE
			S_StartSoundAtVolume(mo.tracer, sfx_facret, mo.laserloudness or 255) -- ph2:adjustable volume needed
			-- S_StartSound(mo.tracer, sfx_facret)
		end
		if mo.tracer and mo.tracer.valid
			mo.tracer.z = (facmo.target and facmo.target.valid) and facmo.target.z or $
		end
	end
end, MT_FACCIOLO_LASER_SPAWN)--spawnpoint

addHook("MobjThinker", function(mo)
	if mo and mo.valid
		local facmo = mo.facciolo
		local radius = facmo.radius/FU-10
		P_MoveOrigin(mo,
		facmo.x+radius*cos(facmo.angle-ANGLE_90)+5*cos(facmo.angle),
		facmo.y+radius*sin(facmo.angle-ANGLE_90)+5*sin(facmo.angle),
		facmo.z+facmo.height
		)
	end
end, MT_FACCIOLO_LASER_FLASH)

addHook("MobjFuse", orbfuse, MT_FACCIOLO_FIREBALL)
addHook("MobjFuse", orbfuse, MT_FACCIOLO_DEATHBALL)

local function A_FaccioloSetStatetimer(mo, var1, var2)
	local facc = mo.facc
	var1 = $ or states[mo.state].var1
	var2 = $ or states[mo.state].var2
	if var1
		if Silverhorn.UltimateMode()
			facc.statetimer = var2 or var1/2
		else
			facc.statetimer = var1
		end
	end
end

local function A_FaccioloIdle(mo)
	local facc = mo.facc
	if (facc.phase == 1) then
		if facc.active
			if facc.active == 2
				if not S_SoundPlaying(mo, sfx_facflt)
					S_StartSound(mo, sfx_facflt)
				end
				facc.ang1 = $ + FixedAngle(8*FU)
				P_InstaThrust(mo, mo.angle+ANGLE_90, 8*cos(facc.ang1))
			end
			if facc.statetimer
				facc.statetimer = $ - 1
			else
				A_FaccioloSetStatetimer(mo, TICRATE/4, TICRATE/6)
				mo.state = ({S_FACCIOLO_PREP})[facc.phase]
			end
		end
	else
		-- TODO: do nothing for now, unless we need to
	end
end

local function A_FaccioloPrep(mo)
	local facc = mo.facc
	local dist = R_PointToDist2(mo.x, mo.y, facc.x, facc.y)
	local ang = R_PointToAngle2(mo.x, mo.y, facc.x, facc.y)
	local radius = mo.radius/FU-7

	P_InstaThrust(mo, ang, dist/ (Silverhorn.UltimateMode() and 4 or 8))

	if dist/FU <= 2
		if not mo.target
			local posstargets = {}
			for p in players.iterate
				if p.mo and p.mo.valid
				and not p.bot
				and p.playerstate == PST_LIVE
					table.insert(posstargets, p.mo)
				end
			end
			if posstargets[1]
				mo.target = posstargets[P_RandomRange(1, #posstargets)]
			else
				A_FaccioloSetStatetimer(mo, P_RandomRange(TICRATE*2, TICRATE*4),  P_RandomRange(TICRATE, TICRATE*3))
				mo.state = S_FACCIOLO_IDLE
				return
			end
		else
			local pmo = mo.target
			mo.angle = R_PointToAngle2(mo.x, mo.y, pmo.x, pmo.y)
		end
		if not mo.tracer
			if P_RandomChance(FU/100*facc.laserchance)
			and not facc.firsttime
				local flash = P_SpawnMobjFromMobj(mo,
				radius*cos(mo.angle-ANGLE_90)+5*cos(mo.angle),
				radius*sin(mo.angle-ANGLE_90)+5*sin(mo.angle),
				mo.height,MT_FACCIOLO_LASER_FLASH) --this is the muzzle flash
				flash.fuse = Silverhorn.UltimateMode() and 60 or 30
				flash.facciolo = mo
				F_MobjUltimateRecolor(flash, SKINCOLOR_FLAME, true)
				facc.statetimer = -1
			else
				local fireball = P_SpawnMobjFromMobj(mo,
					radius*cos(mo.angle-ANGLE_90)+5*cos(mo.angle),
					radius*sin(mo.angle-ANGLE_90)+5*sin(mo.angle),
					mo.height,
					MT_FACCIOLO_FIREBALL
				)
				fireball.scale = 0
				mo.tracer = fireball
				fireball.facciolo = mo
				fireball.charging = true
				fireball.scalespeed = $*2
				fireball.destscale = (FU*3/2)
				facc.statetimer = $*3
				fireball.fuse = 4*TICRATE+facc.statetimer
				facc.firsttime = false
				facc.active = 2
				F_MobjUltimateRecolor(fireball, SKINCOLOR_FLAME, true)
				S_StartSound(mo, sfx_facfcg)
			end
		end
		mo.frame = C|FF_FULLBRIGHT
		if facc.statetimer
			if facc.statetimer == -1
				A_FaccioloSetStatetimer(mo, 30, 60)
				mo.state = S_FACCIOLO_LASER_FIRE
			end
			facc.statetimer = $ - 1
		else
			A_FaccioloSetStatetimer(mo, P_RandomRange(TICRATE*2, TICRATE*4),  P_RandomRange(TICRATE, TICRATE*3))
			mo.state = S_FACCIOLO_FIRETOSS1
			facc.ang1 = ANG1
		end
	end

	-- Set first time health stuff so it wont repeat...
	if (facc.firsttime_truly) then
		-- TODO: deleteme later
		-- mo.facc.health = 8
		-- mo.facc.health = 1
		local bossname = (Silverhorn.UltimateMode() and "Chaos Facciolo" or "Facciolo")
		HitDisplaySH.shownew(mo.facc, HitDisplaySH.facciolo(bossname, 8, mo))
		facc.firsttime_truly = false
	end
end

local function A_FaccioloFiretoss(mo, var1)
	var1 = $ or states[mo.state].var1
	if mo.tracer and mo.tracer.valid
		mo.tracer.charging = false
		mo.tracer = nil
		if var1
			S_StartSound(mo, var1)
		end
	end
end

local function A_FaccioloRefire(mo, var1, var2, chance)
	var1 = $ or states[mo.state].var1
	var2 = $ or states[mo.state].var2
	local facc = mo.facc
	if var1 and var2
		facc.refire = $ + 1
		if facc.refire == 5
			mo.state = var1
			facc.refire = 0
		else
			if P_RandomChance((FU/100)*(chance or states[mo.state].tics))
				A_FaccioloSetStatetimer(mo, TICRATE/4, TICRATE/6)
				mo.state = var2
			else
				A_FaccioloSetStatetimer(mo, P_RandomRange(TICRATE*2, TICRATE*4),  P_RandomRange(TICRATE, TICRATE*3))
				mo.state = var1
				facc.refire = 0
			end
		end
	end
end

local function A_FaccioloDoBarrier(mo)

	local facc = mo.facc

	if (facc.phase == 1) then

		local barstates = {S_FACCIOLO_BARRIER_FORE, S_FACCIOLO_BARRIER_BACK, S_FACCIOLO_BARRIER_ORB}
		if facc.statetimer == TICRATE
			for i = 1, 3
				facc.barrier[i] = P_SpawnMobjFromMobj(mo, 0,0,-192*FU, MT_THOK)
				facc.barrier[i].state = barstates[i]
				facc.barrier[i].dispoffset = i+1
				facc.barrier[i].scale = mo.scale*4
				facc.barrier.target = mo
				S_StartSound(mo, sfx_facbrr)
			end
		end
		for i = 1,3
			if facc.barrier[i] and facc.barrier[i].valid
				P_MoveOrigin(facc.barrier[i], mo.x, mo.y, mo.z - 192*mo.scale)
			end
		end
		if facc.statetimer
			facc.statetimer = $ - 1
		else
			A_FaccioloSetStatetimer(mo, 0,  0)
			mo.state = S_FACCIOLO_IDLE
		end
		mo.frame = (leveltime % 3 == 0) and (I|FF_FULLBRIGHT) or (J|FF_FULLBRIGHT)

	elseif (facc.phase == 2 and facc.ph2_introover) then
		-- Quick and easy barrier skip
		if facc.statetimer
			facc.statetimer = $ - 7
		else
			A_FaccioloSetStatetimer(mo, 0,  0)
			mo.state = S_FACCIOLO2_IDLE
		end
		mo.flags2 = $1 & ~MF2_FRET
	end
end

local function A_FaccioloDoLaser(mo)
	local radius = mo.radius/FU-10
	local facc = mo.facc
	if facc.statetimer % 6 == 0
		local range = P_RandomRange(500, 1500)
		local angle = FixedAngle(P_RandomRange(-90, 90)*FU)
		local ball = P_SpawnMobjFromMobj(mo, range*cos(mo.angle+angle), range*sin(mo.angle+angle),
		(-mo.z)+mo.subsector.sector.ceilingheight-100*FU, MT_FACCIOLO_LASER_SPAWN) --spawnpoint for laser
		ball.fuse = TICRATE*6
		ball.facciolo = mo
		S_StartSound(ball, sfx_faclfr)
	end
	if facc.statetimer
		facc.statetimer = $ - 1
	else
		A_FaccioloRefire(mo, S_FACCIOLO_IDLE, S_FACCIOLO_PREP, 40)
	end
end

local function A_FaccioloFireSpread(mo)
	for i = 1, 8
		local fire = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_FACCIOLO_FIRE)
		fire.momz = FU*6
		P_InstaThrust(fire, mo.angle+(ANGLE_45*i), 5*FU)
		fire.fuse = 5*TICRATE
		F_MobjUltimateRecolor(fire, SKINCOLOR_FLAME, true)
	end
	S_StartSound(mo, mo.info.painsound)

	//Bonus ring
	if not Silverhorn.UltimateMode() and not mo.fuse
		local ring = P_SpawnMobjFromMobj(mo, 0,0,0, MT_FLINGRING)
		ring.scale = FU
		ring.fuse = 8*TICRATE
		P_InstaThrust(ring, mo.angle, -FU)
		P_SetObjectMomZ(ring, 8*FU)
	end
end

-- You can't damage facciolo if he or his barrier are not active, or if he has p2 invulnerability
addHook("ShouldDamage", function(mo)
	if mo and mo.valid
		if mo.state == S_FACCIOLO_HIT
		or mo.state == S_FACCIOLO_BARRIER
		or mo.facc.active < 2
		or mo.facc.invincible then
			return false
		end
	end
end, MT_FACCIOLO_BOSS)

-- Disables toucher if facciolo can't be seen flag is on
addHook("TouchSpecial", function(special, toucher)
	if (toucher.type == MT_PLAYER and special.facc.isntseen) then
		return true
	end
end, MT_FACCIOLO_BOSS)

-- Facciolo damages players if he has his barrier, or p2 invulnerability
addHook("PlayerCanDamage", function(p, facmo)
	if p.mo and p.mo.valid
	and facmo and facmo.valid and facmo.type == MT_FACCIOLO_BOSS
		if facmo.state == S_FACCIOLO_BARRIER or facmo.facc.invincible then
			P_DamageMobj(p.mo, facmo)
			P_DoPlayerPain(p, facmo)
			p.mo.momx = -$
			p.mo.momy = -$
			return false
		end
	end
end)

addHook("MobjDamage", function(mo, attacker, source, damage, damagetype)
	if mo and mo.valid then
		local facc = mo.facc

		S_StartSound(mo, painsounds[P_RandomRange(1, #painsounds)])

		-- Determine if the damage is an instant kill or regular damage
		if (damagetype == DMG_INSTAKILL and damage >= 1) then
			mo.health = 10000 -- Avoid having the boss accidentally be instant killed by irregular damage amounts
			return true
		else
			-- print(string.format("Phase: %d | Boss Health: %d | MOBJ Health %d | DamageType: %d | Damage: %d", facc.phase, facc.health, mo.health, damagetype, damage))
			facc.health = $1 - 1
		end

		if (facc.phase == 1) then

			-- delete objects to prevent getting cheesed by fireballs following you
			for mobj in mobjs.iterate() do
				if mobj and mobj.valid and mobj.facciolo then
					mobj.fuse = 1
				end
			end

			-- Manual health override to transition to the next phase
			if (facc.health == 0 and facc.phase == 1) then
				-- print("========Boss 1 Defeated========")
				facc.active = 0
				facc.phase = 2
				P_StartQuake(16*FU, 2*TICRATE)
				S_StartSound(nil, sfx_kboom1)
				facc.invincible = false
				EventSH.start("facciolo_phase2", {boss=mo})
			end
		end

		if (facc.phase == 2) then

			if (facc.health == facc.health_mid_ref) then
				P_StartQuake(16*FU, 2*TICRATE)
				S_StartSound(nil, sfx_kboom1)
				-- boom
				for player in players.iterate do
					P_FlashPal(player, 1, 6)
				end
			end
			facc.hittime = 35

			if (facc.health == 1) then
				-- print("==========Boss 2 Defeated==========")
				facc.health = $ - 1
				-- Handle end-of-level content
				Silverhorn.Phase2Destruction(mo)
			end
		end
	end
end, MT_FACCIOLO_BOSS)

--Super pierce
addHook("ShouldDamage", function(mo, attacker, source)
	local player = source and (source.type == MT_FACCIOLO_BOSS
	or source.type == MT_FACCIOLO_FIRE or source.type == MT_FACCIOLO_DEATHBALL
	or source.type == MT_FACCIOLO2_SWORDBEAM_V or source.type == MT_FACCIOLO2_SWORDG)
	and mo and mo.player
	if not player then return end
	
	attacker.flags2 = $ | MF2_SUPERFIRE
	if Silverhorn.Inazuma.IsUltimate(player)
		if not P_PlayerInPain(player)
			S_StartSound(mo, sfx_shldls)
			return true
		else
			return
		end
	end

	player.powers[pw_invulnerability] = 0
	player.pflags = $ &~ PF_GODMODE
	if Silverhorn.IsSol(player, true)
		player.solchar.earlyburncancel = true
		return true
	elseif player.powers[pw_super]
		player.powers[pw_super] = 0
		mo.color = player.skincolor
	end
end, MT_PLAYER)

addHook("MobjDeath", function(mo, killer)
	if mo and mo.valid
		if killer and killer.valid
			P_KillMobj(killer)
			killer.sdlfhkgsdfjlhkflsjhglkdfjshglsdkjfhgldfjh = true
		end
		mo.state = S_FACCIOLO_IDLE
		return true
	end
end, MT_FACCIOLO_BOSS)

hud.add(function(v,p)
	if p.mo and p.mo.valid
	and p.mo.sdlfhkgsdfjlhkflsjhglkdfjshglsdkjfhgldfjh
		local facc = v.cachePatch("FACCJOKE")
		v.drawStretched(0, 0, v.width()*FU/facc.width, v.height()*FU/facc.height, facc, V_NOSCALESTART|V_NOSCALEPATCH)
	end
end, "game")


states[S_FACCIOLO_IDLE] = {SPR_FACC, A|FF_FULLBRIGHT, 1, A_FaccioloIdle, 0, 0, S_FACCIOLO_IDLE}
states[S_FACCIOLO_PREP] = {SPR_FACC, B|FF_FULLBRIGHT, 1, A_FaccioloPrep, 0, 0, S_FACCIOLO_PREP}
states[S_FACCIOLO_FIRETOSS1] = {SPR_FACC, D|FF_FULLBRIGHT, 5, A_FaccioloFiretoss, sfx_facfts, 0, S_FACCIOLO_FIRETOSS2}
states[S_FACCIOLO_FIRETOSS2] = {SPR_FACC, E|FF_FULLBRIGHT, 30, nil, 0, 0, S_FACCIOLO_REFIRE}
states[S_FACCIOLO_REFIRE] = {SPR_FACC, B|FF_FULLBRIGHT, 40, A_FaccioloRefire, S_FACCIOLO_IDLE, S_FACCIOLO_PREP, S_NULL}
states[S_FACCIOLO_HIT] = {SPR_FACC, L|FF_FULLBRIGHT, 30, A_FaccioloSetStatetimer, TICRATE, TICRATE, S_FACCIOLO_BARRIER}
states[S_FACCIOLO_BARRIER] = {SPR_FACC, J|FF_FULLBRIGHT, 1, A_FaccioloDoBarrier, 0, 0, S_FACCIOLO_BARRIER}
states[S_FACCIOLO_LASER_FIRE] = {SPR_FACC, C|FF_FULLBRIGHT, 1, A_FaccioloDoLaser, 0, 0, S_FACCIOLO_LASER_FIRE}

states[S_FACCIOLO_FIREBALL] = {SPR_FFBL, FF_FULLBRIGHT|FF_ANIMATE|FF_TRANS20, -1, nil, 4, 3, S_NULL}
states[S_FACCIOLO_FIREBALL_DEATH] = {SPR_FFBL, F|FF_FULLBRIGHT|FF_ANIMATE|FF_TRANS20, 18, A_FaccioloFireSpread, 5, 3, S_NULL}
states[S_FACCIOLO_BARRIER_FORE] = {SPR_FABF, FF_FULLBRIGHT|FF_ANIMATE|FF_TRANS30, 105, nil, 11, 2, S_NULL}
states[S_FACCIOLO_BARRIER_BACK] = {SPR_FABB, FF_FULLBRIGHT|FF_ANIMATE|FF_TRANS30, 105, nil, 11, 2, S_NULL}
states[S_FACCIOLO_BARRIER_ORB] = {SPR_FABO, FF_FULLBRIGHT|FF_ANIMATE|FF_TRANS50, 105, nil, 9, 3, S_NULL}
states[S_FACCIOLO_DEATHBALL] = {SPR_BBEM, FF_FULLBRIGHT|FF_ANIMATE|FF_TRANS20, -1, nil, 3, 3, S_NULL}
states[S_FACCIOLO_DEATHBALL_DEATH] = {SPR_FDBE, FF_FULLBRIGHT|FF_ANIMATE|FF_TRANS20, 18, nil, 5, 3, S_NULL}
states[S_FACCIOLO_LASER] = {SPR_FALZ, FF_FULLBRIGHT|FF_ANIMATE|FF_TRANS10, -1, nil, 1, 3, S_NULL}
states[S_FACCIOLO_FIRE] = {SPR_FFLF, FF_FULLBRIGHT|FF_ANIMATE|FF_TRANS10, -1, nil, 7, 2, S_NULL}
states[S_FACCIOLO_LASER_SPAWN] = {SPR_FMFQ, FF_FULLBRIGHT|FF_ANIMATE|FF_TRANS20, -1, nil, 5, 1, S_NULL}
states[S_FACCIOLO_LASER_RETICLE] = {SPR_TARG, FF_FULLBRIGHT|FF_ANIMATE|FF_TRANS10, -1, nil, 5, 2, S_NULL}

-- \\ Boss 2 \\
-- New idle states required for better non-quirky painstate management
states[S_FACCIOLO2_INTO] = {SPR_FACC, 0}
states[S_FACCIOLO2_IDLE] = {SPR_MNRV, A|FF_FULLBRIGHT, -1, function(mo) mo.flags2 = $1 & ~MF2_FRET end, 0, 0, S_FACCIOLO2_IDLE}
states[S_FACCIOLO2_HIT] = {SPR_MNRV, 0, 10, A_FaccioloSetStatetimer, TICRATE, TICRATE, S_FACCIOLO2_IDLE}
-- \\ Objects \\
states[S_FACCIOLO2_AURA] = {SPR_AUR_, FF_ANIMATE|FF_TRANS20, -1, nil, 3, 5, S_NULL}
states[S_FACCIOLO2_SWORDBEAM] = {SPR_SWD_, FF_ANIMATE|FF_TRANS40, -1, nil, 1, 2, S_NULL}
states[S_FACCIOLO2_SWORDG] = {SPR_SWDG, FF_ANIMATE|FF_TRANS20, -1, nil, 1, 6, S_NULL}
states[S_FACCIOLO2_SPACEPORTAL] = {SPR_ZMXE, FF_FULLBRIGHT|FF_ANIMATE, -1, nil, 25, 2, S_NULL}
states[S_FACCIOLO2_BIGALERT] = {SPR_ALC_, FF_FULLBRIGHT|FF_ANIMATE, -1, nil, 4, 2, S_NULL}
states[S_FACCIOLO2_BLACKHOLE_CHARGE] = {SPR_THK_, A|FF_FULLBRIGHT|FF_TRANS50, 25, nil, 0, 0, S_FACCIOLO2_BLACKHOLE_PULL}
states[S_FACCIOLO2_BLACKHOLE_PULL] = {SPR_THK_, A|FF_FULLBRIGHT|FF_TRANS50, -1, nil, 0, 0, S_NULL}
