/*
Inazuma & Aether
Hugging
	by SMS Alfredo
*/

//Intiate the hug
addHook("MobjCollide", function(thing, tmthing)
	if thing and thing.valid and thing.player and thing.player.panim == PA_IDLE
	and tmthing and tmthing.valid and tmthing.player and tmthing.player.panim == PA_IDLE
	and not thing.player.powers[pw_carry] and not tmthing.player.powers[pw_carry]
	and not thing.player.isjettysyn and not tmthing.player.isjettysyn
	and P_IsObjectOnGround(thing) and P_IsObjectOnGround(tmthing)
	and not thing.player.speed and not tmthing.player.speed
	and ((thing.skin == "inazuma" and tmthing.skin == "aether")
	or (tmthing.skin == "inazuma" and thing.skin == "aether"))
		thing.silverhornhug = tmthing
	end
end, MT_PLAYER)

addHook("PlayerThink", function(player)
	local mo = player.mo
	if not (mo and mo.valid) then return end
	
	if mo.skin != "inazuma" and mo.skin != "aether"
		if mo.state == S_SILVERHORN_HUG
			mo.state = S_PLAY_STND
		end
		mo.silverhornhug = nil
		return
	end
	
	local hugger = mo.silverhornhug
	local hplayer = hugger and hugger.valid and hugger.player
	local huggervalid = hplayer
	and hplayer.panim == PA_IDLE and not hplayer.speed
	and not hplayer.powers[pw_carry] and not hplayer.isjettysyn
	and P_IsObjectOnGround(hugger) and hugger.skin != mo.skin
	and (hugger.skin == "inazuma" or hugger.skin == "aether")
	
	if mo.state == S_SILVERHORN_HUG
		if huggervalid and hugger.state == S_SILVERHORN_HUG
			P_TryMove(mo, hugger.x, hugger.y, true)
			mo.z = hugger.z
			player.pflags = $|PF_STASIS
			
			if player.cmd.buttons & BT_CUSTOM3 and not (leveltime & 7)
				local heart = P_SpawnMobjFromMobj(mo, 0, 0, mo.height, MT_CDLHRT)
				heart.destscale = (5*mo.scale)>>4
				heart.fuse = (5*TICRATE)>>1
				heart.momz = mo.scale
				heart.target = mo
				heart.extravalue1 = mo.x
				heart.extravalue2 = mo.y
			end
		else
			mo.state = S_PLAY_STND
		end
	elseif hugger
		if huggervalid
			P_SpawnLockOn(player, hugger, S_SILVERHORN_HEART)
			
			// Use the same button as for the dance!
			local danceinfo = CC_DanceSkins[mo.skin]
			local button = danceinfo.dancebutton_var and player[danceinfo.dancebutton_var]
				or danceinfo.dancebutton
				or player.cc_buttonmap and player.cc_buttonmap.dance
				or CC_DEFAULTBUTTONS and CC_DEFAULTBUTTONS.dance
				or BT_CUSTOM2
			
			if player.cmd.buttons & button
			and not srb2p
				player.pflags = $|PF_STASIS
				
				if (hplayer.cmd.buttons & button or hplayer.bot == 1)
					mo.state = S_SILVERHORN_HUG
					hugger.state = S_SILVERHORN_HUG
					
					hplayer.pflags = $|PF_STASIS
					
					local x = mo.x - (mo.x - hugger.x)/2
					local y = mo.y - (mo.y - hugger.y)/2
					local z = mo.z - (mo.z - hugger.z)/2
					
					P_TryMove(mo, x, y, true)
					mo.z = z
					P_TryMove(hugger, x, y, true)
					hugger.z = z
					
					S_StartSound(mo.skin == "aether" and mo or hugger, sfx_cdpcm6)
				else
					mo.state = S_PLAY_GLIDE_LANDING
					mo.tics = 2
					mo.sprite2 = SPR2_EDGE
					player.panim = PA_IDLE
				end
			end
		end
	end
	
	mo.silverhornhug = nil
end)