/*
Inazuma the Deer
	by Lach
	& SMS Alfredo
	& Krabs
	& Obama

beta
*/

local SKIN = "inazuma" // skin to run code for
local Silverhorn = Silverhorn // performance hax
local Inazuma = Silverhorn.Inazuma

local BOLT_STREAMS = 3 // maximum number of bolt streams per jump
local BOLTBLAST_CHARGE = TICRATE/2 // amount of time jump must be held to charge Bolt Blast
Inazuma.KEEPZ_TIME = 8 // amount of time to keep vertical speed at 0 after using untargeted bolt stream
local HOMING_TIME = TICRATE
local MAX_BOUNCE = 12*FRACUNIT // maximum vertical speed gained from a successful bolt stream
Inazuma.NEURALSHOCK_ADDSPEED = 5*FRACUNIT // amount of speed to add to normalspeed upon each use of Bolt Blast
Inazuma.NEURALSHOCK_TIME = TICRATE // amount of time Neural Shock can be active for whilst below runspeed
local BARRIER_ENEMY_RANGE = 68*FRACUNIT // electric barrier destroys all enemies within this range
local BARRIER_RING_RANGE = 128*FRACUNIT // electric barrier attracts all rings within this range
local BARRIER_BUSTABLE_RANGE = 64*FRACUNIT // electric barrier busts all breakable wall FOFs within this range
local BARRIER_SPEED = 27*FRACUNIT // speed to slow player to while using electric barrier
local BARRIER_SOUND_TICS = 67 // number of tics ebarrier's sound effect lasts for
local ZAP_TIME = 10 // number of tics to display a tether to an enemy/boss damaged with electric barrier
local LOCKON_COLOR = SKINCOLOR_VAPOR // color to colorize the lock-on marker
local SUPER_LIGHTNINGCOLOR = Silverhorn.EmeraldColor // default lightningcolor for Super Inazuma effects
local SOL_LIGHTNINGCOLOR = SKINCOLOR_PURPLE // default lightningcolor for Sol Inazuma effects
local ULTIMATE_LIGHTNINGCOLOR = SKINCOLOR_JET // default lightningcolor for Ultimate Inazuma effects
local ULTIMATE_TRANSFORMATION_DELAY = 2*TICRATE
local ULTIMATE_BLAST_TIME = TICRATE*2 //Time to charge Lightning Blast for
local ULTIMATE_LASER_RANGE = RING_DIST*2 //Range of Ultimate's Laser
local ULTIMATE_LASER_DIVISION = 64 //How many FRACUNITs per object in the laser
local ULTIMATE_LASER_NUM = ULTIMATE_LASER_RANGE/ULTIMATE_LASER_DIVISION/FRACUNIT
local ULTIMATE_LASER_CHARGE = TICRATE*1 //How long the laser charges
local ULTIMATE_LASER_TIME = TICRATE*4 //How long the laser lasts
local ULTIMATE_LASER_COLOR = SKINCOLOR_SKY //The laser's color
local NEURAL_COLORS = { // colors to show during neural shock
	SKINCOLOR_ICY,
	SKINCOLOR_VAPOR,
	SKINCOLOR_CORNFLOWER
}
local ATTRACTABLE_OBJECTS = { // objects Inazuma can attract with electric barrier
	MT_RING,
	MT_FLINGRING,
	MT_COIN,
	MT_FLINGCOIN,
	// see Attractable() function for MT_REDTEAMRING/MT_BLUETEAMRING handling
}
Inazuma.barrierColors = {
	[SH_PITY] = SKINCOLOR_MOSS,
	[SH_PINK] = SKINCOLOR_PINK,
	[SH_FORCE] = SKINCOLOR_PASTEL,
	[SH_ARMAGEDDON] = SKINCOLOR_SALMON,
	[SH_WHIRLWIND] = SKINCOLOR_WHITE,
	[SH_ELEMENTAL] = SKINCOLOR_SEAFOAM,
	[SH_ATTRACT] = SKINCOLOR_GOLD,
	[SH_THUNDERCOIN] = SKINCOLOR_TAN,
	[SH_FLAMEAURA] = SKINCOLOR_FLAME,
	[SH_BUBBLEWRAP] = SKINCOLOR_AZURE
}
Inazuma.barrierParticles = { // if the ebarrier particles should change state, set that here
	[SH_FLAMEAURA] = S_PUMATRAIL1,
}

// coroutines table
local transThreads = {}

//How each horn frame relates to each spr2 animation
//See https://wiki.srb2.org/wiki/Sprite#Frame_list for how these translate
//to actual frame values
local SILVERHORN_SPRITES = {
	[SPR2_DASH] = "A",
	[SPR2_NFLY] = "A",
	[SPR2_NPUL] = "A",
	[SPR2_EDGE] = "C",
	[SPR2_FALL] = "E",
	["FKIK"] = "G",
	[SPR2_FLY_] = "O",
	[SPR2_DEAD] = "S",
	["FROZ"] = "S",
	[SPR2_GASP] = "U",
	[SPR2_GRND] = "V",
	["GARD"] = "X",
	[SPR2_NSTN] = "Y",
	[SPR2_MLEE] = "Z",
	[SPR2_PAIN] = "3",
	[SPR2_FIRE] = "4",
	[SPR2_RIDE] = "8",
	[SPR2_ROLL] = "9",
	[SPR2_NATK] = "9",
	[SPR2_RUN_] = "d",
	[SPR2_OOF_] = "h",
	[SPR2_CNT1] = "h",
	[SPR2_SKID] = "i",
	[SPR2_SPNG] = "j",
	[SPR2_STND] = "k",
	[SPR2_NSTD] = "k",
	[SPR2_TAL0] = "p",
	[SPR2_TAL7] = "q",
	[SPR2_TAL8] = "r",
	[SPR2_TIRE] = "s",
	[SPR2_WAIT] = "u",
	[SPR2_SIGN] = "w",
	[SPR2_TAL7] = "x",
	[SPR2_TAL8] = "y",
	[SPR2_XTRA] = "z",
	
	--Extra
	[SPR2_DNCE] = -R_Char2Frame("A") - 1,
	[SPR2_WALK] = -R_Char2Frame("2") - 1,
	["JSKI"] = -R_Char2Frame("a") - 1,
	[SPR2_FLY_] = -R_Char2Frame("d") - 1,
	[SPR2_MLEE] = -R_Char2Frame("h") - 1,
	[SPR2_TRNS] = -R_Char2Frame("l") - 1,
	[SPR2_NDRL] = -R_Char2Frame("s") - 1,
	[SPR2_TALB] = -R_Char2Frame("w") - 1,
}
local SILVERHORN_SPRITE2 = SPR2_TAL2
local SILVERHORN_DANCE_SPRITE2 = SPR2_TAL5

local BUTTONS = {BT_JUMP, BT_SPIN, BT_ATTACK, BT_TOSSFLAG}
local BARRIER_SEARCH_RANGE = max(BARRIER_ENEMY_RANGE, BARRIER_RING_RANGE)

Inazuma.FLAGS = {}
Inazuma.FLAGS.BARRIER = 1 << 0
Inazuma.FLAGS.SLOWDOWN = 1 << 1
Inazuma.FLAGS.LIGHTNINGJUMP = 1 << 2
Inazuma.FLAGS.SHIELDABILITY = 1 << 3
Inazuma.FLAGS.DONKED = 1 << 4
Inazuma.FLAGS.SUPER = 1 << 5
Inazuma.FLAGS.ULTIMATE = 1 << 6
Inazuma.FLAGS.ULTIMATESLUMBER = 1 << 7
Inazuma.FLAGS.TRANSFORMING = 1 << 8
Inazuma.FLAGS.NODASHMASK = Inazuma.FLAGS.BARRIER | Inazuma.FLAGS.LIGHTNINGJUMP | Inazuma.FLAGS.ULTIMATE

local NT_NOTINAZUMA = 1
local NT_MIASMA = 2

rawset(_G, "LCF_NODEFAULTCOLOR", 1 << 0)
rawset(_G, "LCF_BOLTSTREAM", 1 << 1)
rawset(_G, "LCF_TRAIL", 1 << 2)
rawset(_G, "LCF_FORCECOLORMAP", 1 << 3)

local function valid(mo)
	return mo and mo.valid
end

local function FixedSquare(n)
	return FixedMul(n, n)
end

local function CopyMobjData(obj, ref) // does NOT copy: skin, color, colorized, angle, scale
	local FLAGS2 = (MF2_SPLAT or 0)|MF2_DONTDRAW|MF2_OBJECTFLIP
	local EFLAGS = MFE_VERTICALFLIP
	
	obj.frame = ($ & FF_FRAMEMASK) | (ref.frame & ~FF_FRAMEMASK)
	obj.flags2 = ($ & ~FLAGS2) | (ref.flags2 & FLAGS2)
	obj.eflags = ($ & ~EFLAGS) | (ref.eflags & EFLAGS)
	obj.renderflags = ref.renderflags
	obj.blendmode = ref.blendmode
	obj.rollangle = ref.rollangle
	obj.mirrored = ref.mirrored
	obj.spritexscale = ref.spritexscale
	obj.spriteyscale = ref.spriteyscale
	obj.spritexoffset = ref.spritexoffset
	obj.spriteyoffset = ref.spriteyoffset
end

function Inazuma.CheckStatus(player)
	local mo = player.mo
	
	if not mo
	or mo.skin ~= SKIN
	or mo.health <= 0
		Inazuma.DestroyInazumaData(player)
		return false
	end
	
	if not player.inazuma
		Inazuma.InitInazumaData(player)
	end
	
	return true
end

function Inazuma.DestroyInazumaData(player)
	local inazuma = player.inazuma
	
	if inazuma == nil
		return
	end
	
	local mo = player.mo
	
	Inazuma.KillUltimateTransformation(player)
	if valid(inazuma.aura)
		P_RemoveMobj(inazuma.aura)
	end
	if valid(inazuma.boltstreamoverlay)
		P_RemoveMobj(inazuma.boltstreamoverlay)
	end
	if valid(inazuma.glove)
		P_RemoveMobj(inazuma.glove)
	end
	if valid(inazuma.eggrobo)
		Inazuma.KillEggrobo(inazuma.eggrobo)
	end
	if valid(player.inazuma_barrier) // temporary until we do co-op mechanics
		P_RemoveMobj(player.inazuma_barrier)
	end
	if #inazuma.lasermobjs
		for i, mobj in ipairs(inazuma.lasermobjs)
			if not (mobj and mobj.valid) then continue end
			mobj.state = S_ULTZUMA_LASEREND
		end
		inazuma.lasermobjs = {}
	end
	player.inazuma = nil
	player.hasnomomentum = false // xmom
	player.blazespindash = nil // MEGA SOL FORM HACK
	
	// followmobj moment
	if player.playerstate == PST_DEAD and Inazuma.CheckSilverhorns(player)
	and mo and mo.skin == SKIN
		mo.sprite2 = SPR2_TAL4
		mo.frame = $ & ~FF_FRAMEMASK
	end
end

function Inazuma.InitInazumaData(player)
	local inazuma = {}
	local mo = player.mo
	
	player.inazuma = inazuma
	mo.inazuma = inazuma
	inazuma.mo = mo
	inazuma.player = player
	
	inazuma.time = -1
	inazuma.neural = {}
	inazuma.particles = {}
	inazuma.boltblast = 0
	inazuma.prevpflags = 0
	inazuma.prevposition = {mo.x, mo.y, mo.z}
	inazuma.prevheight = mo.height
	inazuma.auratics = 0
	inazuma.skidtics = 0
	inazuma.skidframe = -1
	inazuma.bosshits = 0
	
	if player.bot and player.wasultimate
		inazuma.flags = player.wasultimate
	else
		inazuma.flags = 0
	end
	
	inazuma.enemies = {}
	inazuma.rings = {}
	inazuma.fofs = {}
	inazuma.idlers = {}
	inazuma.shieldtime = 0
	inazuma.whirlwind = -1
	inazuma.armageddon = -1
	inazuma.homeangle = player.drawangle
	
	inazuma.transtime = 0
	
	inazuma.lightblast = 0
	inazuma.laser = 0
	inazuma.laserangle = 0
	inazuma.lasermobjs = {}
	
	inazuma.buttons = {}
	
	for i = 1, #BUTTONS
		inazuma.buttons[BUTTONS[i]] = 0
	end
	
	player.normalspeed = skins[SKIN].normalspeed
	player.fakenormalspeed = player.normalspeed // xmom
	inazuma.normalspeed = player.normalspeed
	player.charflags = skins[SKIN].flags
	
	if player.mrce
		player.mrce.hyperimages = true
		player.mrce.canhyper = true
	end
	
	if Silverhorn.UltimateMode() and Inazuma.CanTurnUltimate(player)
		player.powers[pw_super] = 43
		player.rings = max($, 50)
		inazuma.flags = $ | Inazuma.FLAGS.ULTIMATE
		player.charflags = $ & ~SF_NOSUPERSPRITES
		mo.state = $
		
	elseif mo.state == S_PLAY_STND
		mo.state = $ // lol S_PLAY_STND
	end
end

// returns true if the player is Ultimate Inazuma
Inazuma.IsUltimate = function(player)
	local inazuma = player.inazuma
	if not player.powers[pw_super]
		if inazuma and inazuma.flags & Inazuma.FLAGS.ULTIMATE
			inazuma.flags = $ & ~(Inazuma.FLAGS.ULTIMATE|Inazuma.FLAGS.ULTIMATESLUMBER)
			player.charflags = $ | SF_NOSUPERSPRITES
		end
		return false
	end
	return inazuma and inazuma.flags & Inazuma.FLAGS.ULTIMATE
end

// returns true if we have Inazuma's Silverhorns
function Inazuma.CheckSilverhorns(player)
	if srb2p or (player.mo and player.mo.inazumafacciolo)
		return false
	elseif Silverhorn.UltimateMode()
		return MindscapeSessionFlags & MS_ULTIMATEHORNS
	elseif player.bot
		if player.botleader
			return player.botleader.hassilverhorns
		elseif players[0]
			return players[0].hassilverhorns
		end
	else
		return player.hassilverhorns
	end
end

// helper function for Inazuma.GetLightningColor
function Inazuma.GetDefaultLightningColor(player, flags)
	if player
		if Inazuma.IsUltimate(player)
			return ULTIMATE_LIGHTNINGCOLOR
		end
		
		if player.powers[pw_super]
			return (flags & LCF_BOLTSTREAM) and skins[SKIN].supercolor or SUPER_LIGHTNINGCOLOR
		end
		
		if Silverhorn.IsSol(player)
			return SOL_LIGHTNINGCOLOR
		end	
	end
	
	if flags & LCF_NODEFAULTCOLOR
		return SKINCOLOR_NONE
	end
	
	if flags & LCF_BOLTSTREAM
		return SKINCOLOR_BOLTSTREAM
	end
	
	if flags & LCF_TRAIL
		return SKINCOLOR_CERULEAN
	end
	
	return SKINCOLOR_INAFX
end

// returns the appropriate lightningcolor for the given parameters
function Inazuma.GetLightningColor(player, flags)
	flags = $ or 0
	
	if player
		if not (gametyperules & (GTR_FRIENDLY|GTR_RACE))
			// in competitive gametypes, always force effect colors to your skincolor,
			// unless you are using defaults for both color and lightningcolor
			if not (player.inazuma_lightningcolor)
			and player.skincolor == skins[SKIN].prefcolor
				return Inazuma.GetDefaultLightningColor(player, flags)
			end
			return player.skincolor
		end
		
		if player.inazuma_lightningcolor
			return player.inazuma_lightningcolor
		end
	end
	
	return Inazuma.GetDefaultLightningColor(player, flags)
end

// colors @mo to @player's Inazuma effect color
function Inazuma.ColorMobj(mo, player, flags)
	local color = Inazuma.GetLightningColor(player, flags)
	if color
		mo.color = color
		if not (flags and flags & LCF_FORCECOLORMAP)
			mo.renderflags = $ | RF_NOCOLORMAPS
		end
	end
	return mo
end

// calls P_SpawnMobj and colors the object to @player's Inazuma effect color
Inazuma.SpawnMobj = function(x, y, z, type, player)
	return Inazuma.ColorMobj(P_SpawnMobj(x, y, z, type), player)
end

// calls P_SpawnMobjFromMobj and colors the object to @player's Inazuma effect color
Inazuma.SpawnMobjFromMobj = function(mo, x, y, z, type, player)
	return Inazuma.ColorMobj(P_SpawnMobjFromMobj(mo, x, y, z, type), player)
end

// returns true if Bolt Stream is able to target @obj
Inazuma.CanTargetMobj = function(player, obj)
	if not obj.valid
		return false
	end
	
	local isTarget = obj.flags & MF_SHOOTABLE
		and obj.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR)
	
	if (not isTarget) == (not (obj.flags2 & MF2_INVERTAIMABLE)) // object is not targetable
	or obj.flags & (MF_SPRING|MF_NOCLIPTHING) // no targeting springs or objects we can't touch
	or obj.health <= 0 // object needs to be alive
	or obj.player // no targeting players
	or obj.flags2 & MF2_FRET // no targeting flashing objects
	or obj.type == MT_DETON // LOL
	or obj.type == MT_METALSONIC_BATTLE and obj.state == obj.info.spawnstate // no targeting an undamageable Metal Sonic
	or obj.type == MT_RING_REDBOX and player.ctfteam ~= 1 // no targeting ring boxes on the opposite team
	or obj.type == MT_RING_BLUEBOX and player.ctfteam ~= 2
	or (CBW_Battle and obj.type == MT_TARGETDUMMY) // Battle player targetting dummies
	or obj.battleobject // no targeting Battle bashables
		return false
	end
	
	return true
end

// returns the closest object that bolt stream can target, if one is in range
Inazuma.LookForTarget = function(player)
	local mo = player.mo
	local span = FixedAngle(80*FRACUNIT)
	local maxDist = FixedMul(RING_DIST, mo.scale)
	
	local closestDist = maxDist
	local closestTarget
	
	searchBlockmap("objects", function(mo, obj)
		if not Inazuma.CanTargetMobj(player, obj)
			return
		end
		
		// check height
		if mo.eflags & MFE_VERTICALFLIP
			if obj.z + obj.height < mo.z
				return
			end
		else
			if obj.z > mo.z + mo.height
				return
			end
		end
		
		// check 2D plane
		if (twodlevel or mo.flags2 & MF2_TWOD)
		and abs(mo.y - obj.y) > mo.radius
			return
		end
		
		// check distance
		local dist = FixedHypot(FixedHypot(mo.x - obj.x, mo.y - obj.y),
			(mo.z + (mo.height >> 1)) - (obj.z + (obj.height >> 1)))
		
		if dist > closestDist
			return
		end
		
		// check in front/behind
		local angle = R_PointToAngle2(
			mo.x + P_ReturnThrustX(mo, mo.angle, mo.radius),
			mo.y + P_ReturnThrustY(mo, mo.angle, mo.radius),
			obj.x, obj.y)
			
		if abs(angle - mo.angle) > span
			return
		end
		
		// check sight
		if not P_CheckSight(mo, obj)
			return
		end
		
		// ok, this object is good
		closestDist = dist
		closestTarget = obj
	end, mo, mo.x - maxDist, mo.x + maxDist, mo.y - maxDist, mo.y + maxDist)
	
	return closestTarget
end

// toggles the visibilty of the inazuma's shield
// @visible: true if shield should be visible, false if shield should be invisible
// do not call constantly
local function ShieldVisibility(player, visible)
	local shield = player.powers[pw_shield] & SH_NOSTACK
	if not shield
	or player.gotflag or player.gotcrystal
	or player.powers[pw_super]
	or Silverhorn.IsSol(player)
		return
	end
	
	local mo = player.mo
	
	if visible
		player.shieldscale = skins[player.skin].shieldscale
	else
		player.shieldscale = 1
	end
end

// spawns an interpolated trail from Inazuma's previous position to his current position
Inazuma.TRAIL_SPACE = 4*FRACUNIT
Inazuma.TRAIL_MAX = INT8_MAX
Inazuma.SpawnTrail = function(mo, player)
	local inazuma = player and player.inazuma
	local x2, y2, z2 = mo.x, mo.y, mo.z
	local x1, y1, z1
	if inazuma
		local prevPos = inazuma.prevposition
		x1, y1, z1 = prevPos.x, prevPos.y, prevPos.z
	else
		if mo.inatrailpos and mo.inatrailpos.time == leveltime - 1
			x1 = mo.inatrailpos.x
			y1 = mo.inatrailpos.y
			z1 = mo.inatrailpos.z
		else
			x1 = x2 - mo.momx
			y1 = y2 - mo.momy
			z1 = z2 - mo.momz
		end
		mo.inatrailpos = {x = x2, y = y2, z = z2, time = leveltime}
	end
	
	local xDist, yDist, zDist = x1 - x2, y1 - y2, z1 - z2
	local space = FixedMul(Inazuma.TRAIL_SPACE, mo.scale)
	local dist = FixedHypot(FixedHypot(xDist, yDist), zDist)
	local distance = dist
	
	if dist == 0
		return
	end
	
	local color = Inazuma.GetLightningColor(player, LCF_TRAIL)
	local properties = Inazuma.TRAIL_PROPERTIES[skincolors[color].ramp[Inazuma.TRAIL_SKINCOLOR_INDEX]]
	local blendmode = properties.blendmode
	local translucency = properties.translucency << FF_TRANSSHIFT
	local xFactor = FixedDiv(FixedDiv(xDist, dist), mo.scale)
	local yFactor = FixedDiv(FixedDiv(yDist, dist), mo.scale)
	local zFactor = FixedDiv(FixedDiv(zDist, dist)*P_MobjFlip(mo), mo.scale)
	local num = 0
	while dist > 0 and num < Inazuma.TRAIL_MAX
		local thok = P_SpawnMobjFromMobj(mo,
			FixedMul(xFactor, dist),
			FixedMul(yFactor, dist),
			FixedMul(zFactor, dist),
			MT_INAZUMA_TRAIL)
		local oldHeight = thok.height
		thok.color = color
		thok.blendmode = blendmode
		thok.frame = $ & ~FF_TRANSMASK | translucency
		thok.renderflags = $ | RF_NOCOLORMAPS
		thok.destscale = 0
		thok.scalespeed = thok.scale/thok.tics
		P_SetScale(thok, thok.scale - FixedMul(thok.scalespeed, FixedDiv(dist, distance)))
		thok.z = $ + (oldHeight - thok.height)/2
		dist = $ - space
		num = $ + 1
	end
end

// resets all variables related to bolt stream (e.g. to be used when touching the ground)
Inazuma.ResetBoltStream = function(player)
	local inazuma = player.inazuma
	if not BT_SHIELD then player.charflags = $ | SF_NOSHIELDABILITY end
	inazuma.flags = $ & ~(Inazuma.FLAGS.SHIELDABILITY)
	inazuma.boltstream = 0
	inazuma.boltblast = 0
	inazuma.keepz = 0
	inazuma.homing = 0
	inazuma.whirlwind = -1
	inazuma.bosshits = 0
end

// sets the duration of Inazuma's immunity aura (i.e. when touching electrical damage) to @tics, if it is greater than the aura's existing duration
// also spawns the immunity aura if it is not active
local function SpawnImmunityAura(mo, tics)
	local inazuma = mo.inazuma
	if not inazuma return end
	tics = $ or 1
	if not valid(inazuma.aura)
		inazuma.aura = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_OVERLAY) //Spawn a visual effect!
		inazuma.aura.target = mo
		inazuma.aura.state = S_INAZUMA_AURA
	end
	inazuma.auratics = max($, 1)
end

// spawns a shrinking Lightning Jump particle at a random location within @mo's hitbox
// @scale: absolute starting scale of the spawned particle
Inazuma.SpawnParticle = function(mo, scale, type, colorized)
	local player = mo.player
	local r = mo.radius >> FRACBITS
	local x = mo.x + P_RandomRange(-r, r) << FRACBITS
	local y = mo.y + P_RandomRange(-r, r) << FRACBITS
	local z = mo.z + FixedMul(P_RandomFixed(), mo.height)
	local particle
	if player
		particle = Inazuma.SpawnMobj(x, y, z, type or MT_INAZUMA_PARTICLE, player)
	else
		particle = P_SpawnMobj(x, y, z, type or MT_INAZUMA_PARTICLE)
		particle.color = mo.color
	end
	if colorized
		particle.colorized = true
	end
	particle.scale = scale
	particle.destscale = 0
	return particle
end

// spawns a lightning ball, which fires in a random direction from Inazuma's center
// (used in the transformation sequence, repurposed from an old armageddon ebar ability)
local function SpawnLightningBall(player)
	local mo = player.mo
	local inazuma = player.inazuma
	//local barrier = player.inazuma_barrier
	local zoffset = mo.height >> 1
	if mo.eflags & MFE_VERTICALFLIP
		zoffset = 0
	end
	
	local ball = Inazuma.SpawnMobj(mo.x, mo.y, mo.z + zoffset, MT_INAZUMA_LIGHTNINGBALL, player)
	local hangle = FixedAngle(360*P_RandomFixed())
	local vangle = FixedAngle(180*P_RandomFixed()) - ANGLE_90
	local speed = FixedMul(ball.info.speed, mo.scale)
	local hspeed = FixedMul(speed, cos(vangle))
	local vspeed = FixedMul(speed, sin(vangle))
	ball.target = mo
	ball.scale = mo.scale >> 1
	ball.movefactor = mo.scale
	ball.angle = hangle
	ball.aiming = vangle
	P_InstaThrust(ball, hangle, hspeed)
	ball.momz = vspeed
	/*ball.color = barrier.color
	ball.colorized = true*/
	S_StartSound(mo, ball.info.seesound)
	//inazuma.armageddon = P_RandomRange(1, TICRATE)
end

// spawns and colors a lockon marker
function Inazuma.SpawnLockOn(player, target)
	Inazuma.doColorLockon = true
	P_SpawnLockOn(player, target, S_INAZUMA_LOCKON)
	Inazuma.doColorLockon = false
end

// undoes slowdown from Electric Barrier
function Inazuma.RemoveSlowdown(player)
	local inazuma = player.inazuma
	if inazuma.flags & Inazuma.FLAGS.SLOWDOWN
		inazuma.flags = $ & ~Inazuma.FLAGS.SLOWDOWN // make sure this is removed before calling Inazuma.SetNormalspeed!
		Inazuma.SetNormalspeed(player, max(Inazuma.GetModifiedSpeed(player, skins[player.skin].normalspeed), inazuma.normalspeed))
		player.hasnomomentum = false // xmom
	end
end

// sets Inazuma's normalspeed to @speed
// use this instead of setting normalspeed directly to accomodate for neural shock/ebarrier/xmom
function Inazuma.SetNormalspeed(player, speed)
	local inazuma = player.inazuma
	
	if inazuma.flags & Inazuma.FLAGS.SLOWDOWN // speed changes during electric barrier should affect the speed Inazuma returns to instead
		inazuma.normalspeed = speed
		return
	end
	
	inazuma.normalspeed = (player.isxmomentum and player.fakenormalspeed or player.normalspeed)
	
	if not player.isxmomentum
	or speed < player.fakenormalspeed // xmom slowdown
	or speed > player.normalspeed // xmom undo slowdown
		player.normalspeed = speed
	end
	player.fakenormalspeed = speed
end

function Inazuma.GetModifiedSpeed(player, speed)
	if Silverhorn.IsSol(player)
		speed = 5*$/3
	end
	return speed
end

function Inazuma.SetSol(player)
	Inazuma.SetNormalspeed(player, Inazuma.GetModifiedSpeed(player, skins[player.skin].normalspeed)) // set normalspeed on transformation finish
	player.blazespindash = 1 // MEGA SOL FORM HACK (makes it so normalspeed isn't forced by RushChars)
end

// returns true if the player is capable of transforming into Ultimate Inazuma
function Inazuma.CanTurnUltimate(player)
	return Inazuma.CheckSilverhorns(player) and All7Emeralds(emeralds)
	and (player.rings >= 50 or Silverhorn.UltimateMode())
end

// cancels an Ultimate Inazuma transformation
function Inazuma.KillUltimateTransformation(player)
	local inazuma = player.inazuma
	inazuma.transtime = 0
	transThreads[#player] = nil
	inazuma.flags = $ & ~(Inazuma.FLAGS.TRANSFORMING|Inazuma.FLAGS.ULTIMATESLUMBER)
	if valid(inazuma.transorb)
		P_RemoveMobj(inazuma.transorb)
		inazuma.transorb = nil
	end
	if valid(inazuma.transcharge)
		P_RemoveMobj(inazuma.transcharge)
		inazuma.transcharge = nil
	end
end

// coroutine function for Ultimate Inazuma's transformation
// (in SRB2 Lua, coroutines start functions that can then be paused and resumed later - here, it lets us script the transformation sequence like a stage play)
local function UltimateSequence(player)
	local mo = player.mo
	local inazuma = player.inazuma
	
	local function wait(tics)
		while tics > 0
			tics = $ - 1
			coroutine.yield()
		end
	end
	
	if valid(inazuma.transorb)
		P_RemoveMobj(inazuma.transorb)
		inazuma.transorb = nil
	end
	if valid(inazuma.transcharge)
		P_RemoveMobj(inazuma.transcharge)
		inazuma.transcharge = nil
	end
	inazuma.transtime = 0
	
	S_StartSound(mo, sfx_inzeto)
	
	local fx = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
	fx.color = ULTIMATE_LIGHTNINGCOLOR
	fx.blendmode = AST_ADD
	fx.state = S_ULTZUMA_EXPLODE
	
	
	player.powers[pw_extralife] = 0
	player.powers[pw_super] = 43
	if Silverhorn.UltimateMode()
		player.rings = max($, 50)
	end
	inazuma.flags = $ | Inazuma.FLAGS.ULTIMATE | Inazuma.FLAGS.ULTIMATESLUMBER
	player.charflags = $ & ~SF_NOSUPERSPRITES
	
	for p in players.iterate
		if p == player or (p.mo and p.mo.valid and P_CheckSight(p.mo, mo)
		and R_PointToDist2(0, mo.z, R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y), p.mo.z) < 64*mo.radius)
			P_FlashPal(p, 1, 10)
		end
	end
	
	if player.glidetime // I don't feel like making a custom variable for skipping
		mo.frame = M
		if not (mapheaderinfo[gamemap].levelflags & LF_NOSSMUSIC)
			P_PlayJingle(player, JT_SUPER)
		end
	else
		wait(12)
		mo.frame = $ + 1
		wait(7)
		mo.frame = $ + 1
		wait(7)
		mo.frame = $ + 1
		wait(20)
		mo.frame = $ + 1
		wait(4)
		mo.frame = $ + 1 // open
		wait(10)
		mo.frame = $ - 1
		wait(2)
		mo.frame = $ - 1 // shut
		wait(3)
		mo.frame = $ + 1
		wait(2)
		mo.frame = $ + 1 // open
		wait(4)
		mo.frame = $ - 1
		wait(2)
		mo.frame = $ - 1 // shut
		wait(3)
		mo.frame = $ + 1
		wait(2)
		mo.frame = $ + 1 // open
		wait(TICRATE)
		mo.frame = $ - 1
		wait(1)
		mo.frame = $ - 1 // shut
		wait(2)
		mo.frame = $ + 3
		wait(5)
		mo.frame = $ + 1
		wait(2)
		mo.frame = $ + 1
		wait(2)
		mo.frame = $ + 1
		wait(2)
		mo.frame = $ + 1
		wait(1)
		mo.frame = $ + 1
		wait(1)
		mo.frame = $ + 1
	end
	S_StartSoundAtVolume(mo, sfx_fizzle, 128)
	for i = 1, 48
		local p = displayplayer
		if p and p.valid and (p == player or (p.mo and p.mo.valid and P_CheckSight(p.mo, mo)
		and R_PointToDist2(0, mo.z, R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y), p.mo.z) < 64*mo.radius))
			S_StartSoundAtVolume(nil, sfx_s3k67, 64, p)
			P_StartQuake(24*FRACUNIT,1)
		end
		if i % 2
			SpawnLightningBall(player)
		end
		wait(1)
	end
	S_StartSound(nil, sfx_s3k9f)
	for p in players.iterate
		if p == player or (p.mo and p.mo.valid and P_CheckSight(p.mo, mo)
		and R_PointToDist2(0, mo.z, R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y), p.mo.z) < 64*mo.radius)
			P_FlashPal(p, 1, 8)
		end
	end
	local fx = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
	fx.color = ULTIMATE_LIGHTNINGCOLOR
	fx.blendmode = AST_ADD
	fx.state = S_ULTZUMA_EXPLODE
	inazuma.flags = $ & ~Inazuma.FLAGS.ULTIMATESLUMBER
	if player.glidetime // I don't feel like making a custom variable for skipping
		return
	end
	//Dirk was here lol. Calculations were a pain due to how the flame flows.
	wait(2)
	mo.frame = $ + 1 // N
	wait(2)
	mo.frame = $ + 1 // O
	wait(2)
	mo.frame = $ + 1 // P
	wait(4)
	mo.frame = $ + 1 // Q
	wait(4)
	mo.frame = $ + 1 // R
	wait(4)
	mo.frame = $ - 2 // P
	wait(4)
	mo.frame = $ + 1 // Q
	wait(4)
	mo.frame = $ + 1 // R
	wait(4)
	/*mo.frame = $ + 1 (Frames P Q R)
	wait(24)*/
	if not (mapheaderinfo[gamemap].levelflags & LF_NOSSMUSIC)
		P_PlayJingle(player, JT_SUPER)
	end
	mo.frame = $ + 1 //1 (S)
	wait(4)
	/*mo.frame = $ + 1 (Frames S T U)
	wait(4)*/
	mo.frame = $ + 4 //1 (W)
	wait(4)
	/*mo.frame = $ + 1 (Frames V W X)
	wait(4)*/
	mo.frame = $ + 4 //1 (0)
	wait(4)
	mo.frame = $ - 2 //2 (Y)
	wait(4)
	mo.frame = $ + 1 //3 (Z)
	wait(4)
	mo.frame = $ + 1 //4 (0)
	wait(4)
	mo.frame = $ - 2 //5 (Y)
	wait(4)
	mo.frame = $ + 1 //6 (Z)
	wait(4)
	/*mo.frame = $ + 1 (Frames Y Z 0)
	wait(24)*/
	mo.frame = $ + 4 //1 (3)
	wait(4)
	mo.frame = $ - 2 //2 (1)
	wait(2)
	/*mo.frame = $ + 1 // smile (Frames 1 2 3)
	wait(6)*/
	mo.frame = $ + 4 //1 (5)
	wait(4)
	mo.frame = $ + 1 //2 (6)
	wait(4)
	mo.frame = $ - 2 //3 (4)
	wait(4)
	/*mo.frame = $ + 1 (Frames 4 5 6)
	wait(12)*/
end

// if the @shield type should recolor Electric Barrier, returns the color, otherwise returns SKINCOLOR_NONE
function Inazuma.GetBarrierColor(shield)
	if shield & SH_FORCE
		return Inazuma.barrierColors[SH_FORCE]
	end
	return Inazuma.barrierColors[shield] or SKINCOLOR_NONE
end

// spawns a trail of rotated electric papersprite objects from @mo to @item
// object rollangles are dependent on the camera angle, TODO hax for splitscreen
local ModifyPaperSpriteRollAngle
if P_SetOrigin
	ModifyPaperSpriteRollAngle = function(angle) return angle end
else
	ModifyPaperSpriteRollAngle = function(angle, viewAngle)
		if Silverhorn.GetRenderer() ~= Silverhorn.RENDERER_SOFTWARE
		or viewAngle < 0
			return -angle
		end
	end
end
local function RenderTether(mo, item, color)
	local currentX, currentY, currentZ = mo.x, mo.y, mo.z + (mo.height >> 1)
	local goalX, goalY, goalZ = item.x, item.y, item.z + (item.height >> 1)
	local x = goalX - currentX
	local y = goalY - currentY
	local z = goalZ - currentZ
	local hdist = FixedHypot(x, y)
	local dist = FixedHypot(hdist, z)
	
	local hangle = R_PointToAngle2(currentX, currentY, goalX, goalY)
	local vangle = R_PointToAngle2(0, currentZ, hdist, goalZ)
	
	vangle = ModifyPaperSpriteRollAngle($, R_PointToAngle(mo.x, mo.y) - hangle)
	
	local n = dist/mo.scale/32
	for i = 1, n - 1
		local thok = P_SpawnMobj(mo.x + i*x/n, mo.y + i*y/n, mo.z + (mo.height >> 1) - 8*mo.scale + i*z/n, MT_THOK)
		thok.scale = mo.scale >> 1
		thok.state = S_SHOCKWAVE1
		thok.fuse = 1
		thok.frame = P_RandomKey(8) | FF_PAPERSPRITE | FF_FULLBRIGHT
		thok.color = color
		thok.colorized = true
		thok.angle = hangle
		thok.rollangle = vangle
	end
end

// returns true if @obj is attractable by @player's electric barrier (rings, coins, etc.)
// handles team-specific rings in-function, see ATTRACTABLE_OBJECTS table for other objects
local function Attractable(player, obj)
	for i = 1, #ATTRACTABLE_OBJECTS
		if obj.type == ATTRACTABLE_OBJECTS[i]
			return true
		end
	end
	return (player.ctfteam and player.ctfteam == (obj.type - MT_REDTEAMRING + 1))
end

// returns the distance from the center of @mo to the approximate edge of @obj
local function Distance(mo, obj)
	return FixedHypot(FixedHypot(obj.x - mo.x, obj.y - mo.y) - obj.radius, abs(obj.z + (obj.height >> 1) - mo.z - (mo.height >> 1)) - (obj.height >> 1))
end

// searchBlockmap function to look for objects that can be damaged or attracted by electric barrier
// adds @obj to inazuma.enemies if it is damagable, or inazuma.rings if it is attractable
local localsearchrange
local localenemyrange
local localringrange
local function BarrierObjectSearch(mo, obj)
	if not (obj.valid and obj.health)
		return
	end
	
	local player = mo.player
	local inazuma = player.inazuma
	local barrier = player.inazuma_barrier
	
	if obj.flags & MF_SHOOTABLE
	and not (obj.flags & (MF_NOTHINK|MF_NOCLIP|MF_NOCLIPTHING))
	and obj.health > 0
	and Distance(mo, obj) <= localenemyrange
		if obj.player and CBW_Battle
			CBW_Battle.PlayerTouch(mo,obj)
			if not mo.pushtics and not obj.pushtics
			and mo.pushed == obj and obj.pushed == mo
				S_StartSound(mo, sfx_xsgtk)
				table.insert(inazuma.enemies, {mo = obj, tics = ZAP_TIME})
			end
			return
		end
		
		if P_DamageMobj(obj, mo, mo, 1, barrier.info.mass)
			if obj and obj.valid
				S_StartSound(mo, sfx_xsgtk)
				table.insert(inazuma.enemies, {mo = obj, tics = ZAP_TIME})
			end
		elseif obj.type == MT_METALSONIC_BATTLE
		and obj.state == obj.info.spawnstate
		and not (obj.flags2 & MF2_CLASSICPUSH)
			obj.flags2 = $ | MF2_CLASSICPUSH
			S_StartSound(mo, sfx_xsgtk)
			table.insert(inazuma.enemies, {mo = obj, tics = ZAP_TIME})
		end
		return
	end
	
	if Attractable(player, obj)
	and Distance(mo, obj) <= localringrange
	and P_CanPickupItem(player)
	and not (obj.flags & (MF_NOTHINK|MF_NOCLIP|MF_NOCLIPTHING))
	and (not valid(obj.tracer) or obj.tracer == mo)
	and not valid(obj.inazuma)
		obj.inazuma = mo
		obj.flags = $ | MF_NOCLIP
		if valid(obj.hprev)
			obj.hprev.hnext = obj.hnext
		end
		if valid(obj.hnext)
			obj.hnext.hprev = obj.hprev
		end
		table.insert(inazuma.rings, obj)
		return
	end
end

// searchBlockmap function to affect nearby enemies while using electric barrier's attraction shield ability
local function BarrierAttractionSearch(mo, obj)
	if not (obj.valid and obj.health)
		return
	end
	
	local barrier = mo.player.inazuma_barrier
	
	if obj.flags & (MF_ENEMY|MF_SHOOTABLE) == MF_ENEMY|MF_SHOOTABLE
	and not (obj.flags & (MF_NOTHINK|MF_NOCLIP|MF_NOCLIPTHING))
	and Distance(mo, obj) <= localsearchrange
		local angle = R_PointToAngle2(obj.x, obj.y, mo.x, mo.y)
		local dist = FixedHypot(mo.x - obj.x, mo.y - obj.y)
		local zangle = R_PointToAngle2(0, obj.z, dist, barrier.z)
		P_Thrust(obj, angle, 3*FixedMul(cos(zangle), mo.scale))
		obj.momz = $ + 3*FixedMul(sin(zangle), mo.scale)
		RenderTether(mo, obj, barrier.color)
		return
	end
end

// searchBlockmap function to look for lines that border sectors within electric barrier's range
// adds all found sectors to localsectors to be processed for bustable FOFs after the search
local localsectors
local function BarrierLineSearch(mo, line)
	local x, y = P_ClosestPointOnLine(mo.x, mo.y, line)
	local v1 = line.v1
	local v2 = line.v2
	local minx = min(v1.x, v2.x)
	local maxx = max(v1.x, v2.x)
	local miny = min(v1.y, v2.y)
	local maxy = max(v1.y, v2.y)
	local dist
	
	x = min(max($, minx), maxx)
	y = min(max($, miny), maxy)
	dist = FixedHypot(mo.x - x, mo.y - y)
	
	if dist > localsearchrange
		return
	end
	
	local sector = line.frontsector
	for i = 1, 2
		if valid(sector)
			local added = false
			for j = 1, #localsectors
				if sector == localsectors[j][1]
					if dist < localsectors[j][3]
						localsectors[j][2] = {x, y}
					end
					added = true
					break
				end
			end
			if not added
				table.insert(localsectors, {sector, {x, y}, dist})
			end
		end
		sector = line.backsector
	end
end

// returns true if @player, who must be Inazuma, can use electric barrier if spin is pressed
local function CanUseBarrier(player)
	local mo = player.mo
	local inazuma = player.inazuma
	
	if player.powers[pw_carry]
	or player.exiting
	or (not P_IsObjectOnGround(player.mo) and not (player.pflags & PF_JUMPED))
	or mo.state >= S_PLAY_SUPER_TRANS1 and mo.state <= S_PLAY_SUPER_TRANS6
	or player.homing
	or inazuma.homing
	or inazuma.laser
	or player.pflags & (PF_SPINNING|PF_SLIDING)
	or player.weapondelay
	or P_PlayerInPain(player)
	or not player.charability
	or not valid(player.inazuma_barrier)
	or inazuma.flags & (Inazuma.FLAGS.SHIELDABILITY|Inazuma.FLAGS.TRANSFORMING)
	or (player.isxmomentum and (mo.state == S_PLAY_TRICKUP
	or mo.state == S_PLAY_TRICKDOWN))
	or (CBW_Battle and player.exhaustmeter == 0)
		return false
	end
	return true
end

// Neural Shock ticker
local function TickNeuralShock(player)
	local inazuma = player.inazuma
	local mo = player.mo
	
	if inazuma.neuralshock
		local speed = FixedHypot(FixedHypot(mo.momx - player.cmomx, mo.momy - player.cmomy), mo.momz)
		speed = FixedDiv($, mo.scale)
		
		if player.gotflag or player.gotcrystal
			inazuma.neuralshock = 0
			Inazuma.SetNormalspeed(player, Inazuma.GetModifiedSpeed(player, skins[player.skin].normalspeed))
			S_StartSound(mo, sfx_kc65)
		elseif speed < player.runspeed >> ((mo.eflags & MFE_UNDERWATER) / MFE_UNDERWATER)
		and not (inazuma.flags & Inazuma.FLAGS.LIGHTNINGJUMP)
			inazuma.neuralshock = $ - 1
			if inazuma.neuralshock <= 0
				inazuma.neuralshock = 0
				Inazuma.SetNormalspeed(player, Inazuma.GetModifiedSpeed(player, skins[player.skin].normalspeed))
				S_StartSound(mo, sfx_kc65)
			end
		else
			inazuma.neuralshock = Inazuma.NEURALSHOCK_TIME
		end
	end
	if inazuma.neuralshock and not inazuma.homing
		player.charflags = $ | SF_RUNONWATER
	else
		player.charflags = $ & ~SF_RUNONWATER
	end
end

// Bolt Blast ticker (to be run during jump)
local function TickBoltBlast(player)
	local inazuma = player.inazuma
	local mo = player.mo
	
	if inazuma.boltblast
		if inazuma.buttons[BT_JUMP]
		and not (inazuma.flags & Inazuma.FLAGS.BARRIER)
		and player.pflags & PF_THOKKED
			inazuma.boltblast = $ - 1
			if inazuma.boltblast == 0
				local speed = FixedHypot(mo.momx, mo.momy)
				local speedvar = player.isxmomentum and "fakenormalspeed" or "normalspeed"
				Inazuma.SetNormalspeed(player, max(player[speedvar], Inazuma.GetModifiedSpeed(player, skins[player.skin].normalspeed)) + Inazuma.NEURALSHOCK_ADDSPEED)
				P_InstaThrust(mo, mo.angle, max(speed, FixedMul(player[speedvar] >> ((mo.eflags & MFE_UNDERWATER) / MFE_UNDERWATER), mo.scale)))
				inazuma.keepz = Inazuma.KEEPZ_TIME
				inazuma.neuralshock = Inazuma.NEURALSHOCK_TIME
				player.drawangle = mo.angle
				player.pflags = $ | PF_NOJUMPDAMAGE
				if Inazuma.IsUltimate(player)
					mo.state = S_PLAY_FLOAT_RUN
				else
					mo.state = S_INAZUMA_DASH
					inazuma.boltstream = 0
				end
				S_StartSound(mo, sfx_boltbl)
				
				local fx = Inazuma.SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK, player)
				fx.state = S_BOLTBLAST
			elseif inazuma.boltblast < BOLTBLAST_CHARGE - 8
				local n = 4
				local scale = mo.scale
				local thok = P_SpawnMobj(mo.x, mo.y, mo.z + (mo.height >> 1) + 4*P_MobjFlip(mo)*scale, MT_THOK)
				thok.sprite = SPR_IZFX
				thok.scale = (scale << 1) - (leveltime % n) * scale / n
				thok.blendmode = AST_ADD
				thok.renderflags = $ | RF_FULLBRIGHT
				thok.fuse = 1
			end
		else
			inazuma.boltblast = 0
		end
	end
end

// Immunity Aura ticker
local function TickAura(player)
	local mo = player.mo
	local inazuma = player.inazuma
	local aura = inazuma.aura
	local sprite2 = mo.sprite2 & ~FF_SPR2SUPER
	
	if inazuma.auratics
		inazuma.auratics = $ - 1
		if valid(aura)
			Inazuma.ColorMobj(aura, player)
			aura.spriteyoffset = 0
			if Inazuma.IsUltimate(player)
				if (aura.frame & FF_FRAMEMASK) <= states[aura.state].var1
					aura.frame = $ + states[aura.state].var1 + 1
				end
				if sprite2 == SPR2_STND
					aura.spriteyoffset = $+16*FRACUNIT
				end
			end
			if sprite2 == SPR2_ROLL or sprite2 == SPR2_TWIN
			or sprite2 == SPR2_TAL3
				aura.spriteyoffset = $-16*FRACUNIT
			end
		end
	elseif valid(aura)
		P_RemoveMobj(aura)
		inazuma.aura = nil
	end
end

// Electric barrier "thinker"
local function TickPlayerBarrier(player)
	local mo = player.mo
	local inazuma = player.inazuma
	local barrier = player.inazuma_barrier
	
	if not valid(barrier)
		barrier = P_SpawnMobj(mo.x, mo.y, mo.z, MT_INAZUMA_BARRIER)
		player.inazuma_barrier = barrier
	end
	
	local info = barrier.info
	local shield = player.powers[pw_shield] & SH_NOSTACK
	local gotflag = player.gotflag or player.gotcrystal
	local scale = mo.scale
	local scalespeed = mo.scale >> 2
	local isultimate = Inazuma.IsUltimate(player)
	local activestate = isultimate and info.deathstate or info.painstate
	
	if isultimate 
		if inazuma.lightblast
			scale = (min(inazuma.lightblast, ULTIMATE_BLAST_TIME) + 20) * $ / ULTIMATE_BLAST_TIME
		else
			scale = $ * 2
		end
	end
	if Silverhorn.IsSol(player)
		if inazuma.armageddon > 0
			scale = 4*$/3 + FixedMul(inazuma.armageddon, $)
		elseif scale < 4*scale/3
		    scale = 4*$/3
		elseif barrier.scale > scale
			scalespeed = $ << 2
		end	
	elseif ((shield & SH_FORCE or shield == SH_BUBBLEWRAP) and not gotflag)
	or Silverhorn.IsSol(player)
		scale = 4*$/3
	elseif (shield == SH_ARMAGEDDON and not gotflag)
	or Inazuma.IsUltimate(player)
		if inazuma.armageddon > 0
			scale = $ + FixedMul(inazuma.armageddon, $)
		elseif barrier.scale > scale
			scalespeed = $ << 2
		end
	end
	
	// initialization
	if not (barrier.flags2 & MF2_DONTRESPAWN)
		barrier.flags2 = $ & ~MF2_LINKDRAW | MF2_DONTRESPAWN
		barrier.scale = 0
	end
	
	// open/close barrier
	barrier.scalespeed = scalespeed
	if inazuma.flags & Inazuma.FLAGS.BARRIER
		barrier.destscale = scale
		barrier.threshold = $ - 1
		if barrier.threshold <= 0
		or not S_SoundPlaying(barrier, sfx_ebar)
			barrier.threshold = BARRIER_SOUND_TICS
			S_StartSound(barrier, sfx_ebar)
		end
	elseif barrier.destscale ~= 0
		barrier.destscale = 0
		barrier.threshold = 0
		S_StopSound(barrier)
	end
	
	// toggle barrier visibility based on scale
	if barrier.scale <= barrier.scalespeed >> 1
	and not (inazuma.flags & Inazuma.FLAGS.TRANSFORMING)
		if barrier.state ~= info.spawnstate
			barrier.state = info.spawnstate
			ShieldVisibility(player, true)
		end
	elseif barrier.state ~= activestate
	or shield ~= barrier.shield
		barrier.state = activestate
		ShieldVisibility(player, false)
	end
	
	// set color & properties based on current shield
	local color = Inazuma.GetBarrierColor(shield)
	if color
	and not Silverhorn.IsSol(player)
		barrier.color = color
		barrier.colorized = true
	else
		Inazuma.ColorMobj(barrier, player, LCF_FORCECOLORMAP)
		barrier.colorized = false
	end
	
	// I'm not dealing with this shit
	barrier.eflags = $ & ~MFE_VERTICALFLIP
	barrier.flags2 = $ & ~MF2_OBJECTFLIP
	
	// teleport barrier to player's position
	P_MoveOrigin(barrier, mo.x, mo.y, mo.z + (mo.height >> 1))
	if mo.eflags & MFE_VERTICALFLIP
		barrier.z = $ - FixedMul(player.height - info.height, mo.scale)
	end
	
	// resets
	barrier.shield = shield
end

// Electric Barrier ticker
local function TickElectricBarrier(player)
	local inazuma = player.inazuma
	local mo = player.mo
	local isultimate = Inazuma.IsUltimate(player)
	local barrier
	local zapcolor = isultimate and SKINCOLOR_JET or SKINCOLOR_SKY
	
	TickPlayerBarrier(player) // this performs followmobj-like behavior for electric barriers and should ensure they are spawned
	barrier = player.inazuma_barrier
		
	if inazuma.flags & Inazuma.FLAGS.BARRIER
		if not inazuma.buttons[BT_SPIN]
		or mo.state == S_INAZUMA_BOLTSTREAM
		or not CanUseBarrier(player)
			if inazuma.whirlwind > 0
				inazuma.whirlwind = 0
			end
			inazuma.armageddon = -1
			inazuma.flags = $ & ~Inazuma.FLAGS.BARRIER
			if not isultimate or inazuma.lightblast
				Inazuma.RemoveSlowdown(player)
				
				//Throw Lightning Blast
				if inazuma.lightblast
					if CanUseBarrier(player)
						if inazuma.lightblast >= ULTIMATE_BLAST_TIME
							inazuma.laser = 1 //Start laser
						else
							//Fire blast
							local speed = FixedHypot(mo.momx, mo.momy)
							local blast = P_SpawnMobjFromMobj(mo, 0,0,0, MT_INAZUMA_LIGHTNINGBLAST)
							blast.target = mo
							S_StartSound(mo, blast.info.seesound)
							P_InstaThrust(blast, mo.angle, max(FixedMul(blast.info.speed, mo.scale), speed))

							//Blast visuals and scale
							blast.color = barrier.color
							blast.eflags = $ | (mo.eflags & MFE_VERTICALFLIP)
							blast.shadowscale = FRACUNIT
							blast.scale = (min(inazuma.lightblast, ULTIMATE_BLAST_TIME) + 20) * mo.scale / (ULTIMATE_BLAST_TIME/2)
							blast.fuse = ULTIMATE_BLAST_TIME + min(inazuma.lightblast, ULTIMATE_BLAST_TIME)*2/3
							
							//Bouncy blast!
							if inazuma.lightblast >= ULTIMATE_BLAST_TIME/2
								blast.flags = $ | MF_BOUNCE | MF_GRENADEBOUNCE
							end
							
							//Inazuma state
							mo.state = S_INAZUMA_FIRE
							player.drawangle = mo.angle
							player.powers[pw_justsprung] = max($, mo.tics)
							player.weapondelay = max($, mo.tics)
							
							//Speed redirection
							if player.cmd.forwardmove or player.cmd.sidemove
								speed = max($/2, 16*mo.scale)
								mo.momx = $/2
								mo.momy = $/2
								mo.momz = -mo.tics * P_GetMobjGravity(mo)
								P_Thrust(mo, player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove*FRACUNIT), speed)
							elseif not P_IsObjectOnGround(mo)
								mo.momz = -mo.tics * P_GetMobjGravity(mo)
							end
						end
					end
					
					mo.blendmode = AST_TRANSLUCENT
					inazuma.lightblast = 0
				end
			elseif not P_IsObjectOnGround(mo)
				mo.momz = $/2
			end
		else
			local flip = P_MobjFlip(mo)
			local grounded = P_IsObjectOnGround(mo)
			local shield = player.powers[pw_shield] & SH_NOSTACK
			local sol = Silverhorn.IsSol(player)
			
			if (player.gotflag or player.gotcrystal)
				shield = 0
			elseif sol or isultimate
				shield = SH_PROTECTFIRE|SH_PROTECTELECTRIC|SH_PROTECTWATER
			end
			
			local moz = mo.z + (mo.height >> 1)
			local scale = barrier.scale
			local speed = FixedHypot(mo.momx - player.cmomx, mo.momy - player.cmomy)
			local fallspeed = -2*mo.scale
			if isultimate and not inazuma.lightblast
				if player.cmd.buttons & BT_JUMP
					fallspeed = 24*mo.scale
				else
					fallspeed = -24*mo.scale
				end
			elseif inazuma.whirlwind > 0
				fallspeed = 3*mo.scale
			end
			
			if not grounded and not (player.gotflag or player.gotcrystal)
				if isultimate
					mo.momz = $ + flip*fallspeed/8 - P_GetMobjGravity(mo)
					if fallspeed > 0
						mo.momz = flip*min(fallspeed, flip*mo.momz)
					else
						mo.momz = flip*max(fallspeed, flip*mo.momz)
					end
				else
					mo.momz = flip*max(fallspeed, flip*mo.momz)
				end
			end
			
			// SEARCH AND DESTROY
			localsearchrange = FixedMul(scale, BARRIER_SEARCH_RANGE)
			localenemyrange = FixedMul(scale, BARRIER_ENEMY_RANGE)
			localringrange = FixedMul(scale, BARRIER_RING_RANGE)
			searchBlockmap("objects", BarrierObjectSearch, mo,
				mo.x - localsearchrange, mo.x + localsearchrange,
				mo.y - localsearchrange, mo.y + localsearchrange)
			
			localsearchrange = FixedMul(scale, BARRIER_BUSTABLE_RANGE)
			localsectors = {{mo.subsector.sector, {mo.x, mo.y}, 0}}
			searchBlockmap("lines", BarrierLineSearch, mo,
				mo.x - localsearchrange, mo.x + localsearchrange,
				mo.y - localsearchrange, mo.y + localsearchrange)
			for i = 1, #localsectors
				local sector = localsectors[i][1]
				
				for fof in sector.ffloors()
					if not fof.valid
					or (fof.flags & (FF_EXISTS|FF_BLOCKPLAYER|FF_BUSTUP)) ~= (FF_EXISTS|FF_BLOCKPLAYER|FF_BUSTUP)
						continue
					end
					
					local x = localsectors[i][2][1]
					local y = localsectors[i][2][2]
					local z
					local topz
					local bottomz
					
					if fof.t_slope
						topz = P_GetZAt(fof.t_slope, x, y)
					else
						topz = fof.topheight
					end
					
					if fof.b_slope
						bottomz = P_GetZAt(fof.b_slope, x, y)
					else
						bottomz = fof.bottomheight
					end
					
					z = min(max(moz, bottomz), topz)
					
					if FixedHypot(localsectors[i][3], z - moz) <= localsearchrange
						table.insert(inazuma.fofs, {info = {["x"] = x, ["y"] = y, ["z"] = z, ["height"] = 0}, tics = ZAP_TIME})
						Silverhorn.MobjBustFOF(mo, fof)
					end
				end
			end
			
			// shield abilities
			if shield & SH_PROTECTFIRE // Elemental & Flame: fire trails
				if speed > 5*mo.scale
				and grounded
				and leveltime & 1
				and not (mo.eflags & (MFE_UNDERWATER|MFE_TOUCHWATER))
					if (sol or isultimate) and gametyperules & GTR_FRIENDLY
						Inazuma.doColorSpinFire = mo
					end
					P_ElementalFire(player)
					Inazuma.doColorSpinFire = nil
				end
			end
			if shield & SH_PROTECTELECTRIC // Attraction: pull in nearby enemies
				localsearchrange = FixedMul(scale, BARRIER_ENEMY_RANGE) << 2
				searchBlockmap("objects", BarrierAttractionSearch, mo,
					mo.x - localsearchrange, mo.x + localsearchrange,
					mo.y - localsearchrange, mo.y + localsearchrange)
				if shield == SH_ATTRACT and not BT_SHIELD
				and (player.pflags & (PF_JUMPED|PF_THOKKED) == PF_JUMPED)
					local target = P_LookForEnemies(player, false, false)
					if valid(target)
						P_SpawnLockOn(player, target, S_LOCKON2)
					end
				end
			end
			if (shield == SH_ARMAGEDDON or sol or isultimate)
			and not inazuma.lightblast
				if inazuma.armageddon < 0
					inazuma.armageddon = 2*FRACUNIT
				end
				inazuma.armageddon = max($ - mo.scalespeed, 0)
			end	
			if shield == SH_WHIRLWIND or shield == SH_THUNDERCOIN or sol
				if inazuma.whirlwind
				and player.pflags & PF_JUMPED
					if inazuma.whirlwind < 0
						if inazuma.buttons[BT_SPIN] == 1
							inazuma.whirlwind = TICRATE
							if shield & SH_PROTECTELECTRIC
								local momz = mo.momz
								local pflags = player.pflags
								local state = mo.state
								P_DoJumpShield(player)
								mo.momz = momz
								player.pflags = pflags
								mo.state = state
							else
								S_StartSound(mo, sfx_wdjump)
							end
						end
					else
						inazuma.whirlwind = $ - 1
					end
				end
			elseif inazuma.whirlwind
				inazuma.whirlwind = -1
			end
			
			// Lightning Blast Charge
			if inazuma.lightblast
				if not ((inazuma.lightblast/4 - 1) % (TICRATE/4))
				and inazuma.lightblast <= ULTIMATE_BLAST_TIME
					S_StopSoundByID(mo, sfx_s3k45)
					S_StartSound(mo, sfx_s3k45)
					mo.blendmode = AST_ADD
				elseif inazuma.lightblast > ULTIMATE_BLAST_TIME and (inazuma.lightblast/4) % 2
					mo.blendmode = AST_ADD
				else
					mo.blendmode = AST_TRANSLUCENT
				end
				
				Inazuma.SpawnParticle(mo, mo.scale + min(inazuma.lightblast, ULTIMATE_BLAST_TIME)*156)
				
				if inazuma.lightblast == ULTIMATE_BLAST_TIME
					S_StartSound(mo, sfx_s3k78)
					S_StartSound(mo, sfx_s3k60)
				end
				
				inazuma.lightblast = $ + 1
			end
			
			// Visuals
			local hangle = P_RandomKey(360)*ANG1
			local vangle = P_RandomRange(-180, 180)*ANG1
			local dist = 48*barrier.scale
			local hthrust = FixedMul(cos(vangle), dist)
			
			local spark = P_SpawnMobj(
				mo.x + FixedMul(cos(hangle), hthrust),
				mo.y + FixedMul(sin(hangle), hthrust),
				barrier.z + FixedMul(sin(vangle), dist),
				MT_INAZUMA_PARTICLE)
			spark.target = mo
			spark.scale = mo.scale >> 1
			spark.renderflags = $ | RF_NOCOLORMAPS
			spark.eflags = $ | P_RandomKey(2)*MFE_VERTICALFLIP
			if Inazuma.barrierParticles[shield]
				spark.fuse = spark.tics
				spark.state = Inazuma.barrierParticles[shield]
			elseif Inazuma.GetBarrierColor(shield)
				spark.colorized = true
			end
			spark.color = barrier.color
			table.insert(inazuma.particles, spark)
		end
	end
	
	for i = #inazuma.particles, 1, -1
		local spark = inazuma.particles[i]
		if not spark.valid
			table.remove(inazuma.particles, i)
		else
			spark.momx = (mo.x - spark.x)/5 + mo.momx
			spark.momy = (mo.y - spark.y)/5 + mo.momy
			spark.momz = (barrier.z - spark.z)/5 + mo.momz + mo.pmomz
		end
	end
	
	// zap enemies hurt by electric barrer
	local barrierscale = max(barrier.scale, mo.scale)
	local barriercolor = barrier.color
	
	for i = #inazuma.enemies, 1, -1
		local enemy = inazuma.enemies[i].mo
		if not enemy.valid
		or inazuma.enemies[i].tics <= 0
			table.remove(inazuma.enemies, i)
		else
			RenderTether(mo, enemy, barriercolor)
			inazuma.enemies[i].tics = $ - 1
		end
	end
	
	// zap fof positions busted by electric barrier
	for i = #inazuma.fofs, 1, -1
		if inazuma.fofs[i].tics <= 0
			table.remove(inazuma.fofs, i)
		else
			RenderTether(mo, inazuma.fofs[i].info, barriercolor)
			inazuma.fofs[i].tics = $ - 1
		end
	end
	
	// pull in attracted rings
	for i = #inazuma.rings, 1, -1
		local ring = inazuma.rings[i]
		if not (ring.valid and ring.health)
		or not valid(ring.inazuma)
		or ring.inazuma ~= mo
		or ring.tracer and ring.tracer ~= mo
			if valid(ring)
				ring.inazuma = nil
			end
			table.remove(inazuma.rings, i)
		else
			local hdist = FixedHypot(ring.x - mo.x, ring.y - mo.y)
			local ringz = ring.z + (ring.height >> 1)
			local moz = mo.z + (mo.height >> 1)
			local dist = FixedHypot(hdist, ringz - moz)
			
			if dist > FixedMul(BARRIER_RING_RANGE << 1, barrierscale)
				P_MoveOrigin(ring, mo.x, mo.y, mo.z)
			else
				local shield = player.powers[pw_shield]
				if (player.gotflag or player.gotcrystal)
					shield = 0
				end
				if not (shield & SH_PROTECTELECTRIC)
					local speed = FixedHypot(FixedHypot(ring.momx, ring.momy), ring.momz)
					local angle = R_PointToAngle2(ring.x, ring.y, mo.x, mo.y)
					local zangle = R_PointToAngle2(0, ringz, hdist, moz)
					local hthrust = FixedMul(cos(zangle), speed + 8*mo.scale)
					P_InstaThrust(ring, angle, hthrust)
					ring.momz = FixedMul(sin(zangle), speed + 8*mo.scale)
				end
				RenderTether(mo, ring, barriercolor)
			end
		end
	end
end

// Ultimate Laser ticker
local function TickUltimateLaser(player)
	local inazuma = player.inazuma
	local mo = player.mo
	local isultimate = Inazuma.IsUltimate(player)
	local zapcolor = isultimate and SKINCOLOR_JET or SKINCOLOR_SKY
	local armageddon = (player.powers[pw_shield] & SH_NOSTACK) == SH_ARMAGEDDON
	local lasercolor = armageddon and Inazuma.barrierColors[SH_ARMAGEDDON] or ULTIMATE_LASER_COLOR
	
	//Delete laser
	if not inazuma.laser
		if #inazuma.lasermobjs
			for i, mobj in ipairs(inazuma.lasermobjs)
				if not (mobj and mobj.valid) then continue end
				mobj.state = S_ULTZUMA_LASEREND
			end
			inazuma.lasermobjs = {}
		end
		return
	end
	
	//Stasis
	mo.movefactor = 0
	player.pflags = $ | PF_JUMPSTASIS
	if not (player.pflags & PF_DIRECTIONCHAR)
	or twodlevel or mo.flags2 & MF2_TWOD
		player.pflags = $ | PF_FULLSTASIS
	end
	
	//Set start turn angle
	if inazuma.laser <= 1
		inazuma.laserangle = mo.angle
		
	//Slow turning (not in 2D)
	elseif not (twodlevel or mo.flags2 & MF2_TWOD)
		local curangle = inazuma.laserangle
		local tarangle = mo.angle
		local factor = 128
		
		//Let's see how much we'll turn
		local diff = (tarangle - curangle)
		
		//Apply it!
		if not diff
			//
		else
			diff = $/factor
		end
		
		inazuma.laserangle = $ + diff
	end
	player.drawangle = inazuma.laserangle
	player.powers[pw_justsprung] = max($, 2)
	
	//Midair junk
	if not P_IsObjectOnGround(mo)
		mo.momx = $*15/16
		mo.momy = $*15/16
		mo.momz = -P_GetMobjGravity(mo)
	end
	
	//State and timer
	inazuma.laser = $ + 1
	if inazuma.laser < ULTIMATE_LASER_CHARGE
		if inazuma.laser == 2
			mo.state = S_PLAY_SKID
			mo.tics = ULTIMATE_LASER_CHARGE
			player.panim = PA_DASH
			S_StartSound(mo, sfx_inzlz1)
			S_StartSound(mo, sfx_inlaz1 + (leveltime % 5))
			
			//Charge effect
			local charge = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_OVERLAY)
			charge.target = mo
			charge.state = S_ULTZUMA_CHARGE
			charge.color = lasercolor
			charge.tics = ULTIMATE_LASER_CHARGE
			charge.blendmode = AST_ADD
		end
		return
	elseif inazuma.laser > ULTIMATE_LASER_TIME + ULTIMATE_LASER_CHARGE
		inazuma.laser = 0
		TickUltimateLaser(player) //Delete laser
		return
	else
		mo.state = S_INAZUMA_FIRE
		if inazuma.laser == ULTIMATE_LASER_CHARGE
			S_StopSoundByID(mo, sfx_inzlz1)
			S_StartSound(mo, sfx_inzlz2)
		end
	end
	
	//Ring effect
	if not (inazuma.laser % 4)
		local factor = (inazuma.laser % 8) and 1 or 0
		local hoop = P_SpawnMobjFromMobj(mo, 0,0, mo.info.height/3*factor, MT_THOK)
		hoop.angle = player.drawangle + ANGLE_90
		hoop.color = SKINCOLOR_SUPERSILVER1
		hoop.colorized = true
		hoop.state = S_INAZUMA_HOOP
		hoop.scale = mo.scale >> 1
		hoop.destscale = mo.scale << 1
		hoop.scalespeed = mo.scale/10
		
		hoop.blendmode = AST_ADD
		if factor
			factor = 2
		else
			factor = 4
			hoop.scale = $ << 1
			hoop.destscale = $ << 1
		end
		P_TryMove(hoop, mo.x + P_ReturnThrustX(mo, player.drawangle, mo.radius*factor),
		mo.y + P_ReturnThrustY(mo, player.drawangle, mo.radius*factor), true)
	end
	
	//Create laser
	if not #inazuma.lasermobjs
		for i = 1, ULTIMATE_LASER_NUM
			local laser = P_SpawnMobjFromMobj(mo, 0,0,0, MT_THOK)
			laser.state = S_ULTZUMA_LASERSTART
			laser.color = lasercolor
			
			laser.scalespeed = FixedMul($, laser.scale)
			P_SetScale(laser, laser.scale/64)
			laser.destscale = $/64 + min(i, ULTIMATE_LASER_NUM/2)*$
			
			if armageddon
				laser.colorized = true
				laser.scalespeed = $*2
				P_SetScale(laser, laser.scale*2)
				laser.destscale = $*2
			end
			
			table.insert(inazuma.lasermobjs, laser)
		end
	end
	
	//Iterate through laser objects
	local maxlaser = nil
	for i, laser in ipairs(inazuma.lasermobjs)
		if not valid(laser) then continue end
		
		//Move laser into position
		laser.movefactor = ULTIMATE_LASER_DIVISION*laser.scale
		local dist = laser.movefactor/2*(i - 1)
		laser.height = 1
		
		local x = mo.x + P_ReturnThrustX(mo, player.drawangle, dist + mo.radius*4)
		local y = mo.y + P_ReturnThrustY(mo, player.drawangle, dist + mo.radius*4)
		local z = mo.z + mo.height/2 + mo.height/8*P_MobjFlip(mo)
		
		P_MoveOrigin(laser, x, y, z)
		
		//Laser squish
		local squish = (i - inazuma.laser)*ANG20*2
		laser.spritexscale = FRACUNIT*3/2 + sin(squish)/8
		laser.spriteyscale = FRACUNIT + cos(squish)/8
		
		//Laser sprite
		if laser.state == S_ULTZUMA_LASER
			local state = states[laser.state]
			local frame = ((i + inazuma.laser)/state.var2) % (state.var1 + 1)
			frame = $ + (state.frame & FF_FRAMEMASK)
			laser.frame = ($ &~ FF_FRAMEMASK) + frame
		end
		
		//Explode effect
		if inazuma.laser == ULTIMATE_LASER_CHARGE and i == 1
			local fx = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
			fx.color = laser.color
			fx.blendmode = AST_ADD
			fx.state = S_ULTZUMA_EXPLODE
			P_MoveOrigin(fx, laser.x, laser.y, fx.z)
		end
		
		//Set max x and y
		if i == #inazuma.lasermobjs
			maxlaser = laser
		end
	end
	
	//Set up laser bounds
	if not maxlaser then return end
	local angle = player.drawangle + ANGLE_90
	local zmax1 = mo.z + mo.height*3
	local zmax2 = mo.z - mo.height*2
	
	//Iterate through all the blockmaps the laser is in and find objects to kill
	local rings = 0
	local ringsound = sfx_itemup
	local flags = MF_SHOOTABLE | MF_ENEMY | MF_BOSS
	local spikeytypes = {
		[MT_SPIKE] = true,
		[MT_WALLSPIKE] = true,
		[MT_EGGSHIELD] = true,
		[MT_CYBRAKDEMON_ELECTRIC_BARRIER] = true,
	}
	for i, laser in ipairs(inazuma.lasermobjs)
		if not valid(laser) then continue end
		searchBlockmap("objects", function(laser, mobj)
			//Check shootability
			local spikey = spikeytypes[mobj.type]
			if not mobj.health
			or not (mobj.flags & flags or spikey or Attractable(player, mobj))
				return
			end
			
			//Check position bounds
			if mobj.z > zmax1 or mobj.z + mobj.height < zmax2
			or P_AproxDistance(mobj.x - laser.x, mobj.y - laser.y) > laser.movefactor + mobj.radius
				return
			end
			
			//Kill you!
			if not (mobj.flags & flags)
				if not spikey
					rings = $ + 1
					if mobj.type != MT_RING and mobj.type != MT_FLINGRING
						ringsound = mobj.info.deathsound
					end
				elseif mobj.type == MT_CYBRAKDEMON_ELECTRIC_BARRIER
					local brak = mobj.target
					if brak and brak.valid and brak.type == MT_CYBRAKDEMON
					and not (brak.flags & (MF_SPECIAL|MF_SHOOTABLE))
						brak.flags = $|MF_SPECIAL|MF_SHOOTABLE
						P_DamageMobj(mobj, brak, brak, 1000, DMG_INSTAKILL)
					end
				end
				P_KillMobj(mobj, mo, mo, DMG_INSTAKILL)
			elseif mobj.type == MT_FACCIOLO_BOSS
				P_DamageMobj(mobj, mo, mo, 1)
			elseif mobj.type == MT_METALSONIC_BATTLE
				if mobj.hprev and mobj.hprev.type == MT_MSSHIELD_FRONT
					P_KillMobj(mobj.hprev, mo, mo, DMG_INSTAKILL)
				end
				P_KillMobj(mobj, mo, mo, DMG_INSTAKILL)
			else
				P_DamageMobj(mobj, mo, mo, 1000, DMG_INSTAKILL)
				if mobj and mobj.valid
					mobj.flags2 = $ &~ MF2_FRET
				end
			end
		end, laser)
	end
	
	//Get the rings we've collected using the laser
	if rings
		S_StartSound(mo, ringsound)
		P_GivePlayerRings(player, rings)
	end
	
	//Quake
	local p = displayplayer
	if p and p.valid and (p == player or (p.mo and p.mo.valid
	and (P_CheckSight(p.mo, mo) or P_CheckSight(p.mo, maxlaser))))
		local quake = max(16, 64 - (inazuma.laser - ULTIMATE_LASER_CHARGE))
		P_StartQuake(quake*FRACUNIT,1)
	end
end

// Random chance of spawning an electricity particle at Ina's top
local function TickSilverhornZap(player)
	local mo = player.mo
	if P_RandomChance(FRACUNIT/16) and mo and mo.valid and not (player.inazuma
	and player.inazuma.flags & (Inazuma.FLAGS.ULTIMATESLUMBER|Inazuma.FLAGS.TRANSFORMING))
	and mo.state != S_SILVERHORN_HUG
		local zap = P_SpawnMobjFromMobj(mo,32*(P_RandomFixed()-(FRACUNIT/2)),
		32*(P_RandomFixed()-(FRACUNIT/2)),
		16*P_RandomFixed()+(FRACUNIT*48),MT_WATERZAP)
		P_MoveOrigin(zap,zap.x+P_ReturnThrustX(nil,player.drawangle,mo.radius*3/-5),
		zap.y+P_ReturnThrustY(nil,player.drawangle,mo.radius*3/-5),zap.z)
		zap.color = SKINCOLOR_SUPERSKY1
		zap.colorized = true
		zap.momx = mo.momx*2/3
		zap.momy = mo.momy*2/3
		zap.momz = mo.momz*2/3
	end
end

// whenever a player connects to the game, short-circuit any Ultimate Inazuma transformation coroutines to keep things synced
Silverhorn.AddPlayerConnectCallback(function()
	for player in players.iterate
		if not Inazuma.CheckStatus(player)
		or player.mo.state ~= S_ULTZUMA_TRANS2
			continue
		end
		transThreads[#player] = nil
		player.glidetime = 1 // Alfredo I do not like this glidetime hack but I must admit it came in handy
	end
end)

//Silverhorn activation command and I/O support
//For player.hassilverhorns...
//nil means you have not unlocked the command and do not have silverhorns
//0 means you have unlocked the command and do not have silverhorns
//1 means you have unlocked the command and have silverhorns
if not srb2p
	local function silverhorn(player, arg)
		if player.silverhornio and Silverhorn.UltimateMode()
			CONS_Printf(player, "You cannot change fate.")
			return
		elseif player.silverhornio and player.hassilverhorns == nil
			CONS_Printf(player, "You have not yet freed Inazuma's soul. The golden reflection within the emeralds will guide you past the end.")
			return
		end
		if arg
			if arg == "0" or arg == "default" or arg == "false" or arg == "off"
				player.hassilverhorns = 0
			elseif arg == "1" or arg == "true" or arg == "on"
				player.hassilverhorns = 1
			end
			if player == consoleplayer and player.silverhornio
				if player.hassilverhorns
					Silverhorn.SaveValue("setting", "silverhorn_enabled", true)
				else
					Silverhorn.SaveValue("setting", "silverhorn_enabled", false)
				end
			end
		end
		player.silverhornio = true
	end
	COM_AddCommand("silverhorn", silverhorn)
	COM_AddCommand("silverhorn2", silverhorn, COM_SPLITSCREEN)

	local intializehornio = function(player)
		if not player.silverhornio
		and (player == consoleplayer or player == secondarydisplayplayer)
			local command = "silverhorn"
			if player == secondarydisplayplayer then command = $ + 2 end
			if Silverhorn.LocalData["game"].ms_clear
				if Silverhorn.LocalData["setting"].silverhorn_enabled
					CommandQueue_Add(command.." 1")
				else
					CommandQueue_Add(command.." 0")
				end
			else
				CommandQueue_Add(command)
			end
		end
	end
	
	addHook("PlayerSpawn", intializehornio)
	for player in players.iterate
		intializehornio(player)
	end
end

//Unlock Silverhorns for every player
//Use when Facciolo is defeated!!
rawset(_G, "UnlockSilverhorn", function(somerandomguy, arg)
	local dideffect = false
	
	for player in players.iterate
		if not Inazuma.CheckSilverhorns(player)
		and player.mo and player.mo.skin == "inazuma"
			for d = 0, 16
				P_SpawnParaloop(player.mo.x, player.mo.y, player.mo.z + player.mo.height,
				64*player.mo.scale, 16, MT_NIGHTSPARKLE, d*ANGLE_22h, nil, true)
			end
			
			if not dideffect
				S_StartSound(nil, sfx_s3k9f)
				if consoleplayer and consoleplayer.valid
					P_FlashPal(consoleplayer, 1, 10)
				end
				dideffect = true
			end
		end
		
		if player.hassilverhorns == nil
			CONS_Printf(player, "\x83 NOTICE:\x80 You can now use the silverhorn command!")
		end
		player.hassilverhorns = 1
	end
	
	//Unlock Silverhorns in Ultimate Mode
	if Silverhorn.UltimateMode()
		MindscapeSessionFlags = $1 | MS_ULTIMATEHORNS
	end
	
	//Unlock the horns in your local save data!
	Silverhorn.SaveValue("game", "ms_clear", true)
	Silverhorn.SaveValue("setting", "silverhorn_enabled", true)
end)

// Main loop

addHook("ThinkFrame", do
	for player in players.iterate
		if not Inazuma.CheckStatus(player)
			continue
		end
		
		local mo = player.mo
		local inazuma = player.inazuma
		
		// remember flags for Ultimate as a bot
		player.wasultimate = inazuma.flags & Inazuma.FLAGS.ULTIMATE
		
		// locals
		
		local flip = P_MobjFlip(mo)
		local actuallygrounded = P_IsObjectOnGround(mo)
		local grounded = actuallygrounded or player.powers[pw_carry]
		local barrier = player.inazuma_barrier
		
		// count buttons held
		
		for i = 1, #BUTTONS
			inazuma.buttons[BUTTONS[i]] = player.cmd.buttons & BUTTONS[i] and $ + 1 or 0
		end
		
		// increase timer
		inazuma.time = max(0, $ + 1)
		
		// NiGHTS mode
		
		if player.powers[pw_carry] == CR_NIGHTSMODE
			if not inazuma.nightsposition
				inazuma.nightsposition = {x = mo.x, y = mo.y, z = mo.z}
			end
			
			local npos = inazuma.nightsposition
			local hdist = FixedHypot(mo.x - npos.x, mo.y - npos.y)
			local dist = FixedHypot(hdist, mo.z - npos.z)
			
			if dist >= 64*mo.scale
				local miasma = P_SpawnMobj(
					npos.x + (mo.x - npos.x)/2,
					npos.y + (mo.y - npos.y)/2,
					npos.z + (mo.z - npos.z)/2, MT_NIGHTSPARKLE)
				miasma.state = S_FACCIOLO_MIASMA1
				miasma.scale = dist/96
				miasma.inazuma_nightsthink = NT_MIASMA
				miasma.target = mo
				miasma.angle = mo.angle
				
				miasma.rollangle = R_PointToAngle2(0, npos.z, hdist, mo.z)
				if player.flyangle >= 90 and player.flyangle < 270
					miasma.rollangle = InvAngle($)
				end
				
				if mo.inazumafacciolo
					miasma.color = player.powers[pw_nights_superloop] and SKINCOLOR_PURPLE or SKINCOLOR_JET
				else
					Inazuma.ColorMobj(miasma, player, LCF_FORCECOLORMAP)
					miasma.spriteyoffset = player.height >> 2
				end
				miasma.colorized = true
				
				inazuma.nightsposition = {x = mo.x, y = mo.y, z = mo.z}
			end
			
		elseif inazuma.nightsposition
			inazuma.nightsposition = nil
		end
		
		// Ultimate Inazuma
		
		local isultimate = false
		
		if mo.state == S_PLAY_WAIT // start transformation
		and inazuma.buttons[BT_SPIN] == 1
		and Inazuma.CanTurnUltimate(player)
			inazuma.flags = $ | Inazuma.FLAGS.TRANSFORMING
			SpawnImmunityAura(mo) // for some reason it only overlays the orb if spawned before it, so that's what we're doing I guess
			player.panim = PA_DASH // make sure we don't get cancelled while super
			if not valid(inazuma.transorb)
				local orb = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_OVERLAY)
				orb.target = mo
				orb.state = S_ULTZUMA_ORB
				inazuma.transorb = orb
			end
			if not valid(inazuma.transcharge)
				local charge = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_OVERLAY)
				charge.target = mo
				charge.state = S_ULTZUMA_CHARGE
				charge.color = SKINCOLOR_SILVER
				inazuma.transcharge = charge
			end
			if not (mapheaderinfo[gamemap].levelflags & LF_NOSSMUSIC)
				S_FadeMusic(0, (ULTIMATE_TRANSFORMATION_DELAY - TICRATE/3)*MUSICRATE/TICRATE, player)
			end
		end
		
		/* the sequence!
			First, rise into the air, spawning a cocoon. You can cancel the transformation if you get knocked out of idle or let go of spin.
			Once the cocoon is formed, the transformation cannot be cancelled! The screen will shake and the level music will stop.
			Then the animation will play.
		*/
		if inazuma.flags & Inazuma.FLAGS.TRANSFORMING
			if mo.state == S_ULTZUMA_TRANS1 // cocoon sequence
				if (player.solchar)
		          player.solchar.earlyburncancel = true
			      player.charflags = $ |SF_SUPER
	            end  
				local tics = states[mo.state].tics
				local flash = P_SpawnMobjFromMobj(inazuma.transorb, 0, 0, 0, MT_OVERLAY)
				
				flash.target = inazuma.transorb
				flash.state = S_ULTZUMA_FLASH
				flash.frame = $ + (states[flash.state].var1 + 1)*(tics - mo.tics)/tics
				flash.scale = 7*$/10
				
				SpawnImmunityAura(mo)
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				mo.reactiontime = max($, 1)
				
				if player == displayplayer
				or player == secondarydisplayplayer
					P_StartQuake((tics - mo.tics)*(tics-mo.tics)*500, 1)
				end
				
				if inazuma.buttons[BT_SPIN] == 1
					S_StartSound(mo, sfx_inzarg)
					mo.state = S_ULTZUMA_TRANS2
					player.glidetime = 1 // I don't feel like making a custom variable for skipping
				end
			elseif mo.state == S_ULTZUMA_TRANS2 // transformation sequence
				local thread = transThreads[#player]
				if not thread
					thread = coroutine.create(UltimateSequence)
					transThreads[#player] = thread
				end
				coroutine.resume(thread, player)
				if coroutine.status(thread) == "dead"
					Inazuma.KillUltimateTransformation(player)
					mo.state = S_PLAY_FLOAT
				else
					mo.momx = 0
					mo.momy = 0
					mo.momz = 0
					mo.reactiontime = max($, 1)
				end
			elseif mo.state ~= S_PLAY_WAIT // cancel transformation
			or not inazuma.buttons[BT_SPIN]
				Inazuma.KillUltimateTransformation(player)
				if not (mapheaderinfo[gamemap].levelflags & LF_NOSSMUSIC)
					P_RestoreMusic(player)
					S_FadeMusic(100, MUSICRATE, player)
				end
				if mo.state == S_PLAY_WAIT
					mo.state = S_PLAY_FALL
				end
			elseif inazuma.transtime > ULTIMATE_TRANSFORMATION_DELAY // transition to transformation sequence
				mo.reactiontime = max($, 1)
				SpawnImmunityAura(mo)
				mo.state = S_ULTZUMA_TRANS1
				S_StartSound(mo, sfx_inzloa)
			else
				inazuma.transtime = $ + 1
				mo.momx = 0
				mo.momy = 0
				mo.momz = flip*max(flip*$, mo.scale)
				SpawnImmunityAura(mo)
				
				local trans = (FF_TRANS10 * (10*(ULTIMATE_TRANSFORMATION_DELAY - inazuma.transtime)/ULTIMATE_TRANSFORMATION_DELAY))
				inazuma.transorb.frame = $ & ~FF_TRANSMASK | trans
				inazuma.transcharge.frame = $ & ~FF_TRANSMASK | trans
			end
		end
		
		isultimate = Inazuma.IsUltimate(player)
		
		if player.powers[pw_super]
			// temporary Ultimate toggle
			/*
			if inazuma.buttons[BT_ATTACK] == 1
				inazuma.flags = $ ^^ Inazuma.FLAGS.ULTIMATE
				player.charflags = $ ^^ SF_NOSUPERSPRITES
				mo.state = $
			end
			*/
			
			// Super stuff
			if not (inazuma.flags & Inazuma.FLAGS.ULTIMATESLUMBER)
				SpawnImmunityAura(mo)
			end
			inazuma.flags = $ | Inazuma.FLAGS.SUPER
			
			if isultimate
				player.charflags = $ | (SF_NOJUMPSPIN|SF_NOJUMPDAMAGE)
				if inazuma.flags & Inazuma.FLAGS.ULTIMATESLUMBER
					mo.color = player.skincolor
				else
					local supercolor = skins[player.skin].supercolor
					local colordiff = mo.color - supercolor
					
					if colordiff >= 0 and colordiff < 5
						mo.color = $ + SKINCOLOR_ULTIMATE1 - supercolor
					end
				end
				
				if not grounded
				and not (player.pflags & PF_JUMPED)
				and not (inazuma.flags & Inazuma.FLAGS.TRANSFORMING)
					player.pflags = $ | PF_JUMPED | PF_NOJUMPDAMAGE
				end
				
				if player.powers[pw_underwater]
					player.powers[pw_underwater] = underwatertics
				end
				if player.powers[pw_spacetime]
					player.powers[pw_spacetime] = spacetimetics
				end
				
				if mo.state == S_PLAY_STND
					mo.anim_duration = min($, 3)
				elseif mo.state == S_PLAY_EDGE
					mo.tics = min($, 3)
				elseif mo.state == S_PLAY_SKID
					if inazuma.skidtics == 0
						local tics
						local speed = FixedDiv(player.speed, mo.scale)
						
						if speed > 10 << FRACBITS
							tics = 2
						else
							tics = 3
						end
						
						inazuma.skidtics = tics
						inazuma.skidframe = ($ + 1) % skins[player.skin].sprites[mo.sprite2].numframes
					end
					inazuma.skidtics = $ - 1
					mo.frame = ($ & ~FF_FRAMEMASK) | inazuma.skidframe
				elseif player.panim == PA_SPRING
				or player.panim == PA_FALL
				or player.panim == PA_JUMP
					mo.state = S_PLAY_FLOAT
				end
			else
				player.charflags = $ & ~(SF_NOJUMPSPIN|SF_NOJUMPDAMAGE)
				if player.panim == PA_RUN
				and mo.state ~= S_INAZUMA_SUPERRUN
					mo.state = S_INAZUMA_SUPERRUN
				end
			end
		elseif Silverhorn.IsSol(player)
			if not (inazuma.flags & Inazuma.FLAGS.ULTIMATESLUMBER)
				SpawnImmunityAura(mo)
			end
			inazuma.flags = $ | Inazuma.FLAGS.SUPER
			player.charflags = $ & ~(SF_NOJUMPSPIN|SF_NOJUMPDAMAGE)
			if player.panim == PA_RUN
			and mo.state ~= S_INAZUMA_SUPERRUN
				mo.state = S_INAZUMA_SUPERRUN
			end
			if player.solchar.istransformed == 2
				Inazuma.SetSol(player)
			end
		elseif inazuma.flags & Inazuma.FLAGS.SUPER
			inazuma.flags = $ & ~Inazuma.FLAGS.SUPER
			player.charflags = $ | (SF_NOJUMPSPIN|SF_NOJUMPDAMAGE)
			player.blazespindash = nil // MEGA SOL FORM HACK
			if mo.state == S_INAZUMA_SUPERRUN
				mo.state = S_PLAY_RUN
			end
		end
		
		// Immunity aura handling
		TickAura(player)
		
		// electric barrier
		TickElectricBarrier(player)
		
		// Laser handling
		TickUltimateLaser(player)
		
		// Lightning jump states
		if inazuma.flags & Inazuma.FLAGS.LIGHTNINGJUMP
			if inazuma.flags & Inazuma.FLAGS.BARRIER
			or flip*mo.momz <= 0
				inazuma.flags = $ & ~Inazuma.FLAGS.LIGHTNINGJUMP
			else
				Inazuma.SpawnParticle(mo, mo.scale >> 1)
			end
		end
		
		// jump actions
		if player.pflags & PF_JUMPED
		and not (mo.state >= S_PLAY_SUPER_TRANS1 and mo.state <= S_PLAY_SUPER_TRANS6)
			local isrunning = player.speed >= FixedMul(player.runspeed, mo.scale)
		
			// jumpdash animation
			if inazuma.flags & Inazuma.FLAGS.NODASHMASK
			or inazuma.shieldtime
				if mo.state == S_INAZUMA_DASH
					mo.state = S_PLAY_FALL
				end
			elseif player.pflags & PF_NOJUMPDAMAGE
				if mo.state == S_INAZUMA_DASH
					if not isrunning
						mo.state = S_PLAY_FALL
					end
				elseif isrunning
					mo.state = S_INAZUMA_DASH
				end
			end
			
			// switch out jump sound
			if not (inazuma.prevpflags & PF_JUMPED) // was not jumping the previous tic
			and player.panim ~= PA_ROLL
			and (player.charflags & SF_NOJUMPSPIN or player.panim ~= PA_JUMP) // not if we're curled
			and S_SoundPlaying(mo, sfx_jump)
				S_StopSoundByID(mo, sfx_jump)
				S_StartSound(mo, isrunning and sfx_inaju2 or sfx_inaju1)
			end
			
			// jump ability handling
			if (player.charability == skins[SKIN].ability or srb2p)
				// bolt blast
				TickBoltBlast(player)
				
				// Bolt stream suspension
				if inazuma.keepz
					mo.momz = -flip
					inazuma.keepz = $ - 1
				end
				
				// homing
				if inazuma.homing
					local normalspeed = max(player.fakenormalspeed, player.normalspeed)
					if player.powers[pw_sneakers] or player.powers[pw_super]
						normalspeed = $ * 5 / 3
					end
					local speed = FixedMul(normalspeed, mo.scale)
					local truespeed = FixedHypot(FixedHypot(mo.momx, mo.momy), mo.momz)
					
					if inazuma.homing < HOMING_TIME
					and truespeed < speed >> 2
						local x = mo.x + FixedMul(mo.radius, cos(inazuma.homeangle))
						local y = mo.y + FixedMul(mo.radius, sin(inazuma.homeangle))
						local z = mo.z + (mo.height >> 1)
						for i = 1, 16
							local hangle = P_RandomKey(360)*ANG1
							local vangle = P_RandomRange(-90, 90)*ANG1
							local spark = P_SpawnMobj(x, y, z, MT_SUPERSPARK)
							spark.scale = mo.scale
							P_InstaThrust(spark, hangle, FixedMul(spark.radius, cos(vangle)))
							spark.momz = FixedMul(spark.radius, sin(vangle))
							spark.color = SKINCOLOR_SUPERGOLD1
							spark.colorized = true
						end
					
						S_StartSound(mo, sfx_donk)
						inazuma.homing = 0
						inazuma.flags = $ | Inazuma.FLAGS.DONKED
						P_InstaThrust(mo, inazuma.homeangle, -(speed >> 3))
						mo.momz = (speed >> 3)*P_MobjFlip(mo)
						if mo.eflags & MFE_UNDERWATER
							mo.momz = $ / 2
						end
						mo.state = S_PLAY_PAIN
						player.pflags = $ | PF_NOJUMPDAMAGE
					else
						local target = inazuma.target
						if valid(target)
						and Inazuma.CanTargetMobj(player, target)
						and not (mo.eflags & MFE_SPRUNG)
							local hdist = FixedHypot(mo.x - target.x, mo.y - target.y)
							local hang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
							local vang = R_PointToAngle2(0, mo.z + (mo.height >> 1), hdist, target.z + (target.height >> 1))
							
							speed = max($, truespeed + mo.scale) --Gradually increase speed
							P_InstaThrust(mo, hang, P_ReturnThrustX(mo, vang, speed))
							mo.momz = P_ReturnThrustY(mo, vang, speed)
							
							inazuma.homing = $ - 1
							player.drawangle = hang
							inazuma.homeangle = hang
						else
							inazuma.homing = 0
						end
					end
				end // charability check
			end // PF_JUMPED check
			
			// reticle
			if (not (player.pflags & PF_THOKKED) or inazuma.boltstream)
			and not inazuma.homing
			and not (inazuma.flags & Inazuma.FLAGS.BARRIER)
			and not inazuma.shieldtime
			and not (BT_SHIELD
			and (player.powers[pw_shield] & SH_NOSTACK) == SH_ATTRACT
			and (player.pflags & (PF_JUMPED|PF_THOKKED) == PF_JUMPED))
				local target = Inazuma.LookForTarget(player)
				if target
					Inazuma.SpawnLockOn(player, target)
				end
			end
		end
		
		// oof
		if inazuma.flags & Inazuma.FLAGS.DONKED
			if actuallygrounded
				if not (player.cmd.forwardmove or player.cmd.sidemove)
					mo.state = S_INAZUMA_OOF
					S_StartSound(mo, sfx_s3k5d)
				end
				inazuma.flags = $ & ~Inazuma.FLAGS.DONKED
			elseif mo.state ~= S_PLAY_PAIN
				inazuma.flags = $ & ~Inazuma.FLAGS.DONKED
			elseif player.cmd.forwardmove or player.cmd.sidemove
			or inazuma.flags & Inazuma.FLAGS.BARRIER
				mo.state = S_PLAY_FALL
				inazuma.flags = $ & ~Inazuma.FLAGS.DONKED
			end
		end
		
		// shield ability timer
		if inazuma.shieldtime
			inazuma.shieldtime = $ - 1
		end
		
		// ground hit stuffs
		if grounded and not inazuma.grounded
			Inazuma.ResetBoltStream(player)
			
		// Allow whirlwind safety jump
		elseif not grounded and not (player.pflags & PF_JUMPED)
		and player.charflags & SF_NOSHIELDABILITY and not BT_SHIELD
			player.charflags = $ &~ SF_NOSHIELDABILITY
		end
		
		// Neural shock
		TickNeuralShock(player)
		
		// Eggrobo smack
		Inazuma.TickSmack(player)
		
		// Visuals
		
		if inazuma.neuralshock
		and mo.state ~= S_INAZUMA_BOLTSTREAM
		or inazuma.transtime
			local ghost = P_SpawnGhostMobj(mo)
			ghost.fuse = 5
			if valid(ghost.tracer)
				P_RemoveMobj(ghost.tracer)
			end
			
			if inazuma.time % 5 == 0
				ghost.color = mo.color
				ghost.colorized = true
			else
				table.insert(inazuma.neural, ghost)
			end
			
			for i = #inazuma.neural, 1, -1
				local ghost = inazuma.neural[i]
				if not valid(ghost)
					table.remove(inazuma.neural, i)
				else
					ghost.height = mo.height
					ghost.angle = player.drawangle
					ghost.color = NEURAL_COLORS[P_RandomKey(#NEURAL_COLORS << 1)] or mo.color
					P_MoveOrigin(ghost, mo.x + FixedMul(3*mo.scale, cos(FixedAngle(P_RandomKey(360)*FRACUNIT))), mo.y + FixedMul(3*mo.scale, sin(FixedAngle(P_RandomKey(360)*FRACUNIT))), mo.z)
				end
			end
		else
			for i = #inazuma.neural, 1, -1
				local ghost = inazuma.neural[i]
				if valid (ghost)
					P_RemoveMobj(ghost)
				end
				table.remove(inazuma.neural, i)
			end
		end
		
		if mo.state == S_INAZUMA_BOLTSTREAM // bolt stream
		or (isultimate and mo.state == S_PLAY_ROLL)
			if mo.state == S_PLAY_ROLL
				mo.state = S_INAZUMA_BOLTSTREAM
			end
			
			local overlay = inazuma.boltstreamoverlay
			if not valid(overlay)
				overlay = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_OVERLAY)
				overlay.skin = mo.skin
				overlay.state = S_INAZUMA_BOLTSTREAM_OVERLAY
				overlay.target = mo
				inazuma.boltstreamoverlay = overlay
			end
			Inazuma.ColorMobj(overlay, player, LCF_BOLTSTREAM)
			CopyMobjData(overlay, mo)
			overlay.movedir = player.drawangle - mo.angle // I KNEW this would come in handy when I added it to 2.2
			overlay.frame = $ | (states[overlay.state].frame & ~FF_FRAMEMASK)
			
			Inazuma.SpawnTrail(mo, player)
			
			/*local trail = Inazuma.SpawnMobj(mo.x, mo.y, mo.z + mo.height/3, MT_INAZUMA_FX, player)
			trail.destscale = mo.scale >> 1
			trail.scale = trail.destscale
			trail.momx = P_RandomRange(-5, 5)*mo.scale
			trail.momy = P_RandomRange(-5, 5)*mo.scale
			trail.momz = P_RandomRange(-5, 5)*mo.scale
			if P_RandomKey(2)
				trail.flags2 = $^^MF2_OBJECTFLIP
				trail.eflags = $^^MFE_VERTICALFLIP
			end
			
			local prevPos = inazuma.prevposition
			local ghost = P_SpawnGhostMobj(inazuma.boltstreamoverlay)
			ghost.height = mo.height
			ghost.fuse = $ - 2
			P_MoveOrigin(ghost, prevPos.x, prevPos.y, prevPos.z)
			if mo.eflags & MFE_VERTICALFLIP
			and inazuma.prevheight ~= mo.height
				ghost.z = $ + inazuma.prevheight - mo.height
			end
			
			for i = 1,2
				local elec = Inazuma.SpawnMobj(
					mo.x + P_RandomRange(-20, 20) << FRACBITS,
					mo.y + P_RandomRange(-20, 20) << FRACBITS,
					mo.z, MT_INAZUMA_FX, player)
				elec.scale = mo.scale/3
				elec.z = $ + FixedMul(mo.height, P_RandomFixed())
				if mo.eflags & MFE_VERTICALFLIP
					elec.z = $ - 10*mo.scale // look, I couldn't work out how the fuck to automate this
				end
				if P_RandomKey(2)
					elec.flags2 = $^^MF2_OBJECTFLIP
					elec.eflags = $^^MFE_VERTICALFLIP
				end
			end
			
			for i = 1,2
				local elec = P_SpawnMobj(
					mo.x + P_RandomRange(-20, 20) << FRACBITS,
					mo.y + P_RandomRange(-20, 20) << FRACBITS,
					mo.z, MT_SUPERSPARK)
				elec.scale = mo.scale/3
				elec.z = $ + FixedMul(mo.height, P_RandomFixed())
				if mo.eflags & MFE_VERTICALFLIP
					elec.z = $ - 10*mo.scale
				end
			end*/
			
			if inazuma.keepz != nil and inazuma.keepz % 3 == 1
				local hoop = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK, player)
				if player.speed < mo.scale
					hoop.angle = player.drawangle + ANGLE_90
				else
					hoop.angle = R_PointToAngle2(0, 0, mo.momx, mo.momy) + ANGLE_90
				end
				Inazuma.ColorMobj(hoop, player, LCF_NODEFAULTCOLOR)
				hoop.colorized = true
				hoop.state = S_INAZUMA_HOOP
				hoop.scale = mo.scale >> 1
				hoop.destscale = mo.scale << 1
				hoop.scalespeed = mo.scale/10
			end
		elseif valid(inazuma.boltstreamoverlay)
			P_RemoveMobj(inazuma.boltstreamoverlay)
			inazuma.boltstreamoverlay = nil
		end
		
		// idle effects
		// DirkTheHusky: We also apply this for the EDGE frames too.
		if (mo.state == S_PLAY_WAIT or mo.state == S_PLAY_EDGE)
		and not isultimate
			local MAXIDLERS = 6
			local camangle = R_PointToAngle(mo.x, mo.y)
			if splitscreen then camangle = player.cmd.angleturn << 16 end
			local x = mo.x + FixedMul(cos(camangle), mo.scale)
			local y = mo.y + FixedMul(sin(camangle), mo.scale)
			local z = mo.z
			local idler
			
			for i = 1, MAXIDLERS
				idler = inazuma.idlers[i]
				if not valid(inazuma.idlers[i])
					idler = P_SpawnMobj(x, y, z, MT_THOK)
					idler.movefactor = P_RandomRange(-5, 5) * mo.scale
					idler.sprite = SPR_XSGB
					idler.scale = mo.scale
					if mo.state == S_PLAY_WAIT
						idler.frame = (i % 2) | FF_FULLBRIGHT | (TR_TRANS10 * P_RandomRange(1, MAXIDLERS))
					elseif mo.state == S_PLAY_EDGE
						idler.frame = P_RandomRange(2,3) | FF_FULLBRIGHT | (TR_TRANS10 * P_RandomRange(1, MAXIDLERS))
					end
					inazuma.idlers[i] = idler
				end
				Inazuma.ColorMobj(idler, player)
				idler.height = mo.height
				P_MoveOrigin(idler, x, y, z + idler.movefactor)
				idler.angle = player.drawangle
				idler.eflags = mo.eflags & MFE_VERTICALFLIP
				idler.tics = 2
			end
			if inazuma.time % 2
				local i = P_RandomRange(1, MAXIDLERS)
				idler = inazuma.idlers[i]
				idler.frame = ($ & ~FF_TRANSMASK) | (TR_TRANS10 * P_RandomRange(1, MAXIDLERS))
				idler.destscale = mo.scale + P_RandomKey(FRACUNIT/8)
				idler.movefactor = P_RandomRange(-5, 5) * mo.scale - flip*FixedMul(idler.destscale - mo.scale, player.height)
			end
			mo.frame = $ | FF_FULLBRIGHT
		else
			for i = #inazuma.idlers, 1, -1
				local idler = inazuma.idlers[i]
				if valid(idler)
					P_RemoveMobj(idler)
				end
				table.remove(inazuma.idlers, i)
			end
		end
		
		// resets
		inazuma.grounded = grounded
		inazuma.prevpflags = player.pflags
		inazuma.prevheight = mo.height
		
		local prevpos = inazuma.prevposition
		prevpos.x, prevpos.y, prevpos.z = mo.x, mo.y, mo.z
	end
end)

//Prevent ring drain while transforming into Ultimate, and halve it while transformed

addHook("PreThinkFrame", function(player)
	for player in players.iterate
		if player.mo and player.mo.valid and player.mo.health
		and player.mo.skin == SKIN and player.inazuma
		and (Inazuma.IsUltimate(player)
		or (player.inazuma.flags & Inazuma.FLAGS.TRANSFORMING and player.powers[pw_super]))
		and not (leveltime % TICRATE) and not player.exiting
		and player.mo.state != S_PLAY_SUPER_TRANS6
		and (player.inazuma.flags & Inazuma.FLAGS.TRANSFORMING
		or Silverhorn.UltimateMode() or not (leveltime % (TICRATE*2)))
			player.rings = $ + 1
		end
	end
end)

// Sets up Inazuma's Bolt Stream

addHook("AbilitySpecial", function(player)
	if not Inazuma.CheckStatus(player)
	or (player.charability ~= skins[SKIN].ability and not srb2p)
		return
	end
	
	local mo = player.mo
	local inazuma = player.inazuma
	
	// Don't activate under these conditions
	if (player.gotflag or player.gotcrystal)
	or not (player.pflags & PF_JUMPED)
	or player.homing
	or inazuma.homing
	or player.pflags & PF_THOKKED and not inazuma.boltstream
		return true
	end
	
	// use shield ability?
	if inazuma.flags & Inazuma.FLAGS.BARRIER
		if not (player.pflags & PF_THOKKED)
		and not player.powers[pw_super]
			inazuma.shieldtime = 2
			if not BT_SHIELD then player.charflags = $ & ~SF_NOSHIELDABILITY end
			player.cmd.buttons = $ & ~BT_SPIN
		elseif inazuma.lightblast
			mo.blendmode = AST_TRANSLUCENT
			inazuma.lightblast = 0
			Inazuma.RemoveSlowdown(player)
		end
		return true
	end
	
	local isultimate = Inazuma.IsUltimate(player)
	
	// set up bolt streams
	if not (player.pflags & PF_THOKKED)
		inazuma.boltstream = BOLT_STREAMS
		player.pflags = $ | PF_THOKKED
	end
	
	local target = Inazuma.LookForTarget(player)
	if target
		inazuma.target = target
		inazuma.homing = HOMING_TIME
		inazuma.homeangle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
	else
		local isSuper = player.powers[pw_super]
		local speed = FixedHypot(mo.momx, mo.momy)
		local normalspeed = (player.xmomentum and player.fakenormalspeed or player.normalspeed)
		
		if mo.eflags & MFE_UNDERWATER
			normalspeed = $ >> 1
		end
		if isSuper or player.powers[pw_sneakers]
			normalspeed = $ * 5 / 3
		end
		if not isSuper
			inazuma.boltstream = $ - 1
		end
		
		speed = max(FixedMul(normalspeed, mo.scale), $)
		P_InstaThrust(mo, mo.angle, speed)
		mo.momz = -P_MobjFlip(mo)
		
		inazuma.keepz = Inazuma.KEEPZ_TIME
		inazuma.boltblast = BOLTBLAST_CHARGE
		player.drawangle = mo.angle
	end
	
	// Set animation
	if inazuma.boltstream
		player.pflags = $ & ~(PF_SPINNING|PF_NOJUMPDAMAGE)
		mo.state = S_INAZUMA_BOLTSTREAM
		S_StartSound(mo, sfx_boltst)
	else
		player.pflags = $ & ~PF_SPINNING | PF_NOJUMPDAMAGE
		if isultimate
			mo.state = S_PLAY_FLOAT_RUN
		else
			mo.state = S_INAZUMA_DASH
		end
		Inazuma.SpawnMobjFromMobj(mo, 0, 0, 0, MT_INAZUMA_FX, player)
		S_StartSound(mo, sfx_xsgtk)
	end
	
	return true
end)

// Electric Barrier

addHook("SpinSpecial", function(player)
	if not Inazuma.CheckStatus(player)
		return
	end
	
	local mo = player.mo
	local inazuma = player.inazuma
	local isultimate = Inazuma.IsUltimate(player)
	
	if player.pflags & PF_SPINDOWN
	or not CanUseBarrier(player)
	or inazuma.flags & Inazuma.FLAGS.BARRIER
	or (P_SuperReady(player) and not BT_SHIELD)
		return
	end
	
	if isultimate and mo.state ~= S_INAZUMA_BOLTSTREAM
	and (P_IsObjectOnGround(mo) or not (player.cmd.buttons & BT_JUMP))
		inazuma.lightblast = 1
	end
	
	if (isultimate and not inazuma.lightblast)
	or Silverhorn.IsSol(player)
		//No slow down for ultimate or sol!
	elseif player.isxmomentum
		player.hasnomomentum = true
		Inazuma.SetNormalspeed(player, 3*player.fakenormalspeed/4)
		inazuma.flags = $ | Inazuma.FLAGS.SLOWDOWN // make sure this is set after calling Inazuma.Normalspeed!
	else
		Inazuma.SetNormalspeed(player, Inazuma.GetModifiedSpeed(player, BARRIER_SPEED))
		inazuma.flags = $ | Inazuma.FLAGS.SLOWDOWN // make sure this is set after calling Inazuma.Normalspeed!
	end
	if player.pflags & (PF_JUMPED|PF_NOJUMPDAMAGE) == PF_JUMPED
		mo.state = S_PLAY_FALL
		player.pflags = $ | PF_NOJUMPDAMAGE
	end
	inazuma.flags = $ | Inazuma.FLAGS.BARRIER
	
	return true
end)

// Thinkframe for the silver horn overlay and Facciolo in NiGHTS
addHook("PostThinkFrame", do for player in players.iterate
	local horn = player.followmobj
	local mo = player.mo
	local hassilverhorns = Inazuma.CheckSilverhorns(player)
	
	if not (mo and mo.valid)
		continue
	end
	
	if mo.skin == SKIN and player.powers[pw_carry] == CR_NIGHTSMODE
	and G_IsSpecialStage() and not hassilverhorns
		if not mo.inazumafacciolo
			mo.inazumafacciolo = true
			mo.eflags = $ | MFE_FORCESUPER
			mo.state = $
		end
	elseif mo.inazumafacciolo
		mo.inazumafacciolo = false
		mo.eflags = $ &~ MFE_FORCESUPER
		mo.state = $
	end
	
	if mo.skin != SKIN then continue end
	
	if mo.inazumafacciolo and not multiplayer
		mo.color = SKINCOLOR_SLATE
	end
	
	if not valid(horn)
		if hassilverhorns
			TickSilverhornZap(player)
		end
		continue
	end
	
	if horn.type ~= skins[SKIN].followitem
		continue
	end
	
	if not (hassilverhorns) or mo.colorized
		horn.state = S_INVISIBLE
		continue
	end
	
	local inazuma = player.inazuma
	
	horn.tracer = mo
	horn.skin = mo.skin
	
	CopyMobjData(horn, mo)
	
	if inazuma and Inazuma.IsUltimate(player) and not (inazuma.flags & Inazuma.FLAGS.ULTIMATESLUMBER)
		Silverhorn.PulseAura(player, horn, SKINCOLOR_SUPERSKY1)
		
		if not (player.pflags&PF_SPINNING) and player.panim != PA_ROLL
		and not (inazuma.flags&Inazuma.FLAGS.TRANSFORMING) and mo.state != S_SILVERHORN_HUG
			local zoffset = FRACUNIT*34
			if mo.eflags & MFE_VERTICALFLIP
				zoffset = $ - FRACUNIT*24
			end
			
			for i=1,2
				local ghost = P_SpawnMobjFromMobj(horn,24*(P_RandomFixed()-(FRACUNIT/2)),
				24*(P_RandomFixed()-(FRACUNIT/2)),
				38*P_RandomFixed()+zoffset,MT_GHOST)
				P_InstaThrust(ghost,player.drawangle,-mo.scale)
				P_MoveOrigin(ghost,ghost.x+P_ReturnThrustX(nil,player.drawangle,mo.radius*3/-5),
				ghost.y+P_ReturnThrustY(nil,player.drawangle,mo.radius*3/-5),ghost.z)
				ghost.sprite = SPR_RTSP
				ghost.frame = P_RandomRange(0, 1)
				ghost.blendmode = AST_ADD
				//ghost.state = S_SPINDUST_FIRE1
				ghost.tics = -1
				ghost.color = SKINCOLOR_SUPERSKY1
				ghost.colorized = true
				P_SetObjectMomZ(ghost,FRACUNIT*3/2,false)
				ghost.scale = $/2
				ghost.fuse = 17
			end
		end
	else
		local frame = SILVERHORN_SPRITES[mo.sprite2] or SILVERHORN_SPRITES[spr2names[mo.sprite2]]
		local dance = false
		if frame == nil
			horn.state = S_INVISIBLE
			continue
		elseif type(frame) == "number" and frame < 0
			frame = abs($) - 1
			dance = true
		end
		
		if type(frame) == "string"
			frame = R_Char2Frame($) or 0
		end
		
		horn.sprite = SPR_PLAY
		horn.sprite2 = dance and SILVERHORN_DANCE_SPRITE2 or SILVERHORN_SPRITE2
		
		frame = $ + (mo.frame & FF_FRAMEMASK)
		if frame >= skins[horn.skin].sprites[horn.sprite2].numframes
			horn.state = S_INVISIBLE
			continue
		end
		horn.frame = ($ &~ FF_FRAMEMASK) | frame
		
		horn.color = player.mo.color
		horn.colorized = player.mo.colorized
		horn.angle = player.drawangle
		horn.scale = player.mo.scale
		horn.radius = player.mo.radius
		horn.height = player.mo.height
		horn.flags2 = $ | MF2_LINKDRAW
		horn.blendmode = player.mo.blendmode
		
		P_MoveOrigin(horn,player.mo.x,player.mo.y,player.mo.z)
		
		TickSilverhornZap(player)
	end
end end)

//Signpost Junk
addHook("MobjThinker", function(mobj)
	if mobj.state != S_SIGNPLAYER then return end
	
	local mo = mobj.target
	local player = mo and mo.valid and mo.player
	if not player or player.followitem != skins[SKIN].followitem
	or not Inazuma.CheckSilverhorns(player) then return end
	
	local ov = mobj.tracer and mobj.tracer.valid and mobj.tracer.tracer
	if not (ov and ov.valid) or ov.skin != SKIN or ov.tics == -1 then return end
	
	ov.sprite2 = SPR2_TAL9
	ov.tics = -1
end, MT_SIGN)

//Make the life icon show silverhorns when you have silverhorns
hud.add(function(v, player, cam)
	if skins[player.skin].name == SKIN
	and Inazuma.CheckSilverhorns(player) and hud.enabled("lives")
	and not (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS)
	and not G_IsSpecialStage()
	and not (player.inazuma and Inazuma.IsUltimate(player)
	and not (player.inazuma.flags & Inazuma.FLAGS.ULTIMATESLUMBER))
		local color = player.skincolor
		if player.realmo and player.realmo.valid
			color = player.realmo.color
		end
		
		local frame = SILVERHORN_SPRITES[SPR2_XTRA]
		if type(frame) == "string"
			frame = R_Char2Frame($) or 0
		end
		
		local patch = v.getSprite2Patch(player.skin,
		SILVERHORN_SPRITE2, false, frame)
		
		v.drawScaled(16*FRACUNIT, 176*FRACUNIT, FRACUNIT/2,
		patch, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER,
		v.getColormap(player.skin, color))
	end
end)

// Can damage while using ebar
addHook("PlayerCanDamage", function(player)
	local inazuma = player.inazuma
	
	if inazuma and inazuma.flags & Inazuma.FLAGS.BARRIER
		return true
	end
end)

// Immunity to electricity (except electricity from another player)

addHook("ShouldDamage", function(mo, inflictor, source, damage, type)
	if mo.skin == SKIN and mo.player
	and (type == DMG_ELECTRIC or Inazuma.IsUltimate(mo.player))
	and not (inflictor and inflictor.player)
	and not (source and source.player)
		SpawnImmunityAura(mo)
		return false
	end
end, MT_PLAYER)

// Inazuma doesn't use shield abilities
addHook("ShieldSpecial", function(player)
	local mo = player.mo
	local inazuma = player.inazuma
	
	if not (inazuma and mo.skin == SKIN and player.charability == skins[SKIN].ability) return end
	
	if inazuma.shieldtime or not (player.pflags & PF_JUMPED)
		inazuma.flags = $ | Inazuma.FLAGS.SHIELDABILITY
		ShieldVisibility(player, true)
		return
	end
	if inazuma.flags & Inazuma.FLAGS.SHIELDABILITY or BT_SHIELD
		return
	end
	return true
end)

// Lightning Jump

Inazuma.LightningJump = function(player, item)
	local mo = player.mo
	local inazuma = player.inazuma
	
	local divisor = Inazuma.GetModifiedSpeed(player, FRACUNIT)
	local momz = FixedDiv(player.normalspeed, divisor)
	
	if item.flags & MF_BOSS
		if inazuma.bosstarget ~= item
			inazuma.bosstarget = item
			inazuma.bosshits = 0
		end
		inazuma.bosshits = $ + 1
		if inazuma.bosshits == item.info.spawnhealth
			local dirk = false
			local aether = false
			for player2 in players.iterate
				if player2.mo
					dirk = player2.mo.skin == "dirk" or $
					aether = player2.mo.skin == "aether" or $
				end
			end
			if not (dirk or aether)
				S_StartSound(mo, sfx_inapr1)
			elseif dirk and (((leveltime/2) & 1) or not aether)
				S_StartSound(mo, sfx_inapr4)
			else
				S_StartSound(mo, sfx_inapr2 + (leveltime & 1))
			end
		end
	end
	
	if player.powers[pw_super]
		mo.momx = FixedDiv(2*$, 3*divisor)
		mo.momy = FixedDiv(2*$, 3*divisor)
		P_SetObjectMomZ(mo, momz/2)
	else
		mo.momx = FixedDiv($, 2*divisor)
		mo.momy = FixedDiv($, 2*divisor)
		P_SetObjectMomZ(mo, 2*momz/5)
	end
	player.pflags = $ & ~PF_STARTJUMP | PF_NOJUMPDAMAGE
	inazuma.flags = $ | Inazuma.FLAGS.LIGHTNINGJUMP
	inazuma.homing = 0
	mo.state = S_PLAY_SPRING
	S_StartSound(mo, sfx_ljmp)
	
	local strike = Inazuma.SpawnMobj(item.x, item.y, item.z, MT_THOK, player)
	strike.scale = mo.scale << 1
	strike.state = S_INAZUMA_LIGHTNINGSTRIKE
	strike.eflags = mo.eflags
	if strike.eflags & MFE_VERTICALFLIP
		strike.z = $ + item.height - strike.height
	end
	
	local flags = item.flags
	item.flags = $ &~ MF_SHOOTABLE
	P_RadiusAttack(strike, mo, 2*mo.radius, DMG_ELECTRIC)
	item.flags = flags
	
	if Inazuma.IsUltimate(player)
		InazumaProjectileStream(mo)
		S_StartSound(mo, sfx_zcrash)
		
		local fx = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		fx.color = ULTIMATE_LIGHTNINGCOLOR
		fx.blendmode = AST_ADD
		fx.state = S_ULTZUMA_EXPLODE
		
		if player == displayplayer or player == secondarydisplayplayer
			P_StartQuake(64*FRACUNIT, 5)
		end
		
		for i = 1, 16
			SpawnLightningBall(player)
		end
	end
end

addHook("MobjDamage", function(item, mo)
	if not valid(mo)
	or not item.valid
		return
	end
	
	local player = mo.player
	local inazuma = player and player.inazuma
	
	if not player or not inazuma
	or not Inazuma.CheckStatus(player)
		return
	end
	
	if inazuma.homing
		Inazuma.LightningJump(player, item)
	end
	
	if player.exhaustmeter == 0
		inazuma.exhaust_cooldown = 0
		S_StartSound(mo,  sfx_s3k5c)
		inazuma.exhaustcolor2 = 3
		mo.exhaustcolor = false
		mo.colorized = true
		mo.color = SKINCOLOR_SKY
	end
	player.exhaustmeter = FRACUNIT
end)

addHook("MobjDeath", function(item, mo) // for monitors
	if not valid(mo)
	or not item.valid
	or not (item.flags & MF_MONITOR)
		return
	end
	
	local player = mo.player
	local inazuma = player and player.inazuma
	
	if not player or not inazuma
	or not Inazuma.CheckStatus(player)
		return
	end
	
	if inazuma.homing
		Inazuma.LightningJump(player, item)
	end
	
	if player.exhaustmeter == 0
		inazuma.exhaust_cooldown = 0
		S_StartSound(mo,  sfx_s3k5c)
		inazuma.exhaustcolor2 = 3
		mo.exhaustcolor = false
		mo.colorized = true
		mo.color = SKINCOLOR_SKY
	end
	player.exhaustmeter = FRACUNIT
end)

// color lockon markers & elemental spin flames

addHook("MobjSpawn", function(marker)
	if Inazuma.doColorLockon
		marker.color = LOCKON_COLOR
		marker.colorized = true
	end
end, MT_LOCKON)

addHook("MobjSpawn", function(fire)
	local mo = Inazuma.doColorSpinFire
	if mo
		fire.state = S_TEAM_SPINFIRE1
		if mo.skin == "aether"
			fire.color = SKINCOLOR_SUPERGOLD5
		elseif mo.player
			fire.color = Inazuma.GetLightningColor(mo.player, 0)
		else
			fire.color = mo.color
		end
	end
end, MT_SPINFIRE)

// Break spikes during Neural Shock

local function KillSpikes(item, mo)
	if item.flags & MF_SOLID
		S_StartSound(mo, item.info.deathsound)
	end
	for obj in item.subsector.sector.thinglist()
		if (obj.type == item.type and obj.health > 0 and obj.flags & MF_SOLID
		and (obj == item or P_AproxDistance(P_AproxDistance(obj.x - item.x, obj.y - item.y), obj.z - item.z) < 56*item.scale))
			P_KillMobj(item, mo, mo, DMG_ELECTRIC)
		end
	end
end

local function SpikeCollide(item, mo)
	local player = mo.valid and mo.player
	local inazuma = player and player.inazuma
	
	if not item.valid
	or not inazuma
	or mo.z > item.z + item.height or item.z > mo.z + mo.height
		return
	end
	
	if inazuma.neuralshock or Inazuma.IsUltimate(player)
		KillSpikes(item, mo)
	end
end

addHook("MobjCollide", SpikeCollide, MT_SPIKE)
addHook("MobjCollide", SpikeCollide, MT_WALLSPIKE)

// object thinkers

local function ProjectileObjectSearch(mo, obj)
	if not (obj.valid and obj.health)
		return
	end
	
	if obj.flags & MF_SHOOTABLE
	and obj.flags & (MF_ENEMY|MF_BOSS)
	and not (obj.flags & (MF_NOTHINK|MF_NOCLIP|MF_NOCLIPTHING))
		local dist = Distance(mo, obj) 
		if dist <= localenemyrange
			mo.tracer = obj
			localenemyrange = dist
		end
	end
end

addHook("MobjThinker", function(mo)
	if not mo.valid return end
	
	local tracer = mo.tracer
	
	if not (valid(tracer) and tracer.health)
		localenemyrange = FixedMul(mo.info.painchance, mo.movefactor)
		searchBlockmap("objects", ProjectileObjectSearch, mo,
			mo.x - localenemyrange, mo.x + localenemyrange,
			mo.y - localenemyrange, mo.y + localenemyrange)
	else
		local speed = FixedMul(mo.info.speed, mo.movefactor)
		local hangle = R_PointToAngle2(mo.x, mo.y, tracer.x, tracer.y)
		local vangle = R_PointToAngle2(0, mo.z + mo.height >> 1, FixedHypot(mo.x - tracer.x, mo.y - tracer.y), tracer.z + tracer.height >> 1)
		mo.angle = $ + (hangle - $)/4
		mo.aiming = $ + (vangle - $)/4
		local hspeed = FixedMul(speed, cos(mo.aiming))
		local vspeed = FixedMul(speed, sin(mo.aiming))
		P_InstaThrust(mo, mo.angle, hspeed)
		mo.momz = vspeed
	end
	if leveltime % 2
		P_SpawnGhostMobj(mo).destscale = 0
	end
	Inazuma.SpawnParticle(mo, mo.scale)
end, MT_INAZUMA_LIGHTNINGBALL)

// This is the most useless thinker in existence
addHook("MobjThinker", function(mo)
	if not mo.valid return end
	
	local target = mo.target
	
	if not mo.color and target and target.valid
	and target.player and target.inazuma
		Inazuma.ColorMobj(mo, target.player, LCF_NODEFAULTCOLOR|LCF_BOLTSTREAM)
	end
	
	if not mo.health or not (mo.flags & MF_MISSILE)
		if S_SoundPlaying(mo, sfx_cdfm54)
			S_StopSoundByID(mo, sfx_cdfm54)
		end
		mo.shadowscale = 0
	else
		if not S_SoundPlaying(mo, sfx_cdfm54)
			S_StartSound(mo, sfx_cdfm54)
		end
		
		if mo.momx or mo.momy
			mo.angle = R_PointToAngle2(0,0, mo.momx, mo.momy)
		elseif not mo.momz and target and target.valid
			P_InstaThrust(mo, mo.angle, FixedMul(mo.info.speed, target.scale))
		end
	end
	
	if leveltime % 2
		P_SpawnGhostMobj(mo).destscale = 0
	end
	
	Inazuma.SpawnParticle(mo, mo.scale)
end, MT_INAZUMA_LIGHTNINGBLAST)

// This is the most useless fuse in existence
addHook("MobjFuse", function(mo)
	if mo.valid and mo.health and mo.flags & MF_MISSILE
		P_KillMobj(mo)
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
	end
	return true
end, MT_INAZUMA_LIGHTNINGBLAST)

// This is the most useless damage collision in existence
addHook("MobjMoveCollide", function(mo, target)
	if mo and mo.valid and mo.health and mo.flags & MF_MISSILE
	and target and target.valid and target.flags & MF_SHOOTABLE and target.health
	and target.z - target.scale <= mo.z + mo.height
	and target.z + target.height + target.scale >= mo.z
		P_DamageMobj(target, mo, mo.target, 1, (not target.player and DMG_ELECTRIC) or 0)
		if not target.health and target.flags2 & MF2_FRET
			target.flags2 = $ & ~MF2_FRET
		end
	end
end, MT_INAZUMA_LIGHTNINGBLAST)

// This is the most useless blocked movement in existence
addHook("MobjMoveBlocked", function(mo)
	if mo and mo.valid and mo.flags & MF_BOUNCE
		mo.threshold = $ + 1
		
		if mo.threshold >= 5
			P_KillMobj(mo)
			return true
		end
	end
end, MT_INAZUMA_LIGHTNINGBLAST)

addHook("MobjThinker", function(mo)
	if not mo.valid
	or mo.inazuma_nightsthink == NT_NOTINAZUMA
	or splitscreen
		return
	end
	
	if not mo.inazuma_nightsthink
		mo.inazuma_nightsthink = NT_NOTINAZUMA
		
		local target = mo.target
		
		if valid(target) and target.skin == SKIN
			P_RemoveMobj(mo)
		end
		return
	end
	
	if mo.frame & FF_PAPERSPRITE
		if R_PointToAngle(mo.x, mo.y) - mo.angle < 0
			mo.frame = $ | FF_HORIZONTALFLIP
		else
			mo.frame = $ & ~FF_HORIZONTALFLIP
		end
	end
end, MT_NIGHTSPARKLE)

// Eggrobo funnies

function Inazuma.SmackAction(mo, var1, var2)
	local player = mo.player
	
	if not player
	or not Silverhorn.Inazuma.CheckStatus(player)
		return
	end
	
	local inazuma = player.inazuma
	local eggrobo = inazuma.eggrobo
	local glove = inazuma.glove
	local frame = mo.frame & FF_FRAMEMASK
	
	if glove.valid
		glove.frame = ($ & ~FF_FRAMEMASK) | (mo.frame & FF_FRAMEMASK)
	end
	
	if frame == A
	or frame == E
		mo.tics = 12
	elseif frame == B
		mo.tics = 12
		eggrobo.state = eggrobo.info.deathstate
		
		if glove.valid
			local ghost = P_SpawnGhostMobj(glove)
			ghost.destscale = INT32_MAX
			ghost.scalespeed = glove.scale/12
			S_StartSound(mo, sfx_s3k4a)
		else
			mo.state = var1
			return
		end
	elseif frame == C
		inazuma.eggrobo = nil
		if eggrobo.valid
			player.skidtime = mo.tics + 12
			P_Thrust(mo, inazuma.smackangle, 36*mo.scale)
			
			S_StartSound(mo, mobjinfo[MT_EGGROBO1].attacksound)
			eggrobo.state = $
			eggrobo.flags = $ & ~MF_NOGRAVITY
			eggrobo.flags2 = $ | MF2_JUSTATTACKED
			P_InstaThrust(eggrobo, eggrobo.angle, -68*mo.scale)
			P_SetObjectMomZ(eggrobo, 16*FRACUNIT)
			eggrobo.z = $ + P_MobjFlip(eggrobo)
		else
			mo.state = var1
			return
		end
	end
	
	A_SetPAnim(mo, var1, var2)
end
states[S_INAZUMA_SMACK].action = Inazuma.SmackAction

function Inazuma.TickSmack(player)
	local inazuma = player.inazuma
	local mo = player.mo
	local glove = inazuma.glove
	local gleam = inazuma.gleam
	local prep = (mo.frame & FF_FRAMEMASK) < C
	
	if valid(gleam)
		gleam.spritexscale = $ << 2
		gleam.spriteyscale = $ >> 2
	end
	
	if mo.state ~= S_INAZUMA_SMACK
		if valid(glove)
			Inazuma.TossGlove(player)
			P_RemoveMobj(glove)
			inazuma.glove = nil
		end
		
		if valid(inazuma.eggrobo)
			Inazuma.KillEggrobo(inazuma.eggrobo)
			inazuma.eggrobo = nil
		end
		
		inazuma.smackposition = nil
		return
	end
	
	if prep
		local pos = inazuma.smackposition
		local x = (pos.x - mo.x)/3
		local y = (pos.y - mo.y)/3
		
		if not P_IsObjectOnGround(mo)
			mo.momz = (pos.z - mo.z)/3
		end
		P_TryMove(mo, mo.x + x, mo.y + y, true)
		
		player.powers[pw_justsprung] = $ + 1
		player.powers[pw_nocontrol] = $ + 1
		player.pflags = $ | PF_JUMPDOWN | PF_USEDOWN
	end
	
	if glove.valid
		A_CapeChase(glove)
		if not prep
			P_MoveOrigin(glove,
				glove.x + P_ReturnThrustX(mo, player.drawangle, FRACUNIT >> 3),
				glove.y + P_ReturnThrustY(mo, player.drawangle, FRACUNIT >> 3),
				glove.z)
		end
	end
end

function Inazuma.SmackEggrobo(player, robo)
	local mo = player.mo
	
	if mo.state == S_INAZUMA_SMACK // don't smack more than one Eggrobo at once
		return
	end
	
	local inazuma = player.inazuma
	
	local clone = P_SpawnMobjFromMobj(robo, 0, 0, 0, MT_SILVERHORN_EGGROBO)
	clone.angle = robo.angle
	clone.color = robo.color
	clone.target = mo
	inazuma.eggrobo = clone
	
	local pos
	inazuma.smackangle = R_PointToAngle2(mo.x, mo.y, clone.x, clone.y)
	pos = {
		x = clone.x - P_ReturnThrustX(mo, inazuma.smackangle, 2*(clone.radius + mo.radius)),
		y = clone.y - P_ReturnThrustY(mo, inazuma.smackangle, 2*(clone.radius + mo.radius)),
		z = clone.z + (mo.eflags & MFE_VERTICALFLIP and clone.height - mo.height or 0)
	}
	inazuma.smackposition = pos
	mo.momx, mo.momy, mo.momz = 0, 0, 0
	Inazuma.SetGloveColor(player, robo.color)
	if player.pflags & PF_DIRECTIONCHAR
		player.drawangle = inazuma.smackangle
	end
	player.powers[pw_justsprung] = $ + 1
	player.powers[pw_nocontrol] = $ + 1
	mo.state = S_INAZUMA_SMACK
	
	local gleam = P_SpawnMobj(
		clone.x/2 + pos.x/2,
		clone.y/2 + pos.y/2,
		((mo.z + mo.height >> 1) / 2) + ((clone.z + clone.height >> 1) / 2),
		MT_GHOST)
	gleam.sprite = SPR_IZFX
	gleam.scale = mo.scale * 3
	gleam.blendmode = AST_SUBTRACT
	gleam.spritexscale = FRACUNIT >> 6
	gleam.spriteyscale = FRACUNIT << 6
	gleam.fuse = 12
	inazuma.gleam = gleam
	S_StartSound(mo, sfx_facret)
	
	P_RemoveMobj(robo)
end

function Inazuma.SetGloveColor(player, color)
	local mo = player.mo
	local inazuma = player.inazuma
	local glove = inazuma.glove
	
	if not valid(glove)
		glove = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_GHOST)
		glove.target = mo
		inazuma.glove = glove
	else
		Inazuma.TossGlove(player)
	end
	
	glove.state = S_INVISIBLE
	glove.sprite = SPR_XSGG
	glove.color = color
end

function Inazuma.TossGlove(player)
	local mo = player.mo
	local glove = player.inazuma.glove
	local junk = P_SpawnMobjFromMobj(mo, 0, 0, 16*FRACUNIT, MT_GHOST)
	junk.flags = $ & ~MF_NOGRAVITY
	junk.fuse = 20
	junk.angle = player.drawangle
	junk.color = glove.color
	junk.state = S_INAZUMA_TOSSEDGLOVE
	junk.momx = mo.momx*2/3
	junk.momy = mo.momy*2/3
	junk.momz = mo.momz*2/3
	P_Thrust(junk, player.drawangle - ANGLE_22h + P_RandomKey(2)*ANGLE_45, -9*mo.scale)
	P_SetObjectMomZ(junk, 7*FRACUNIT, true)
	S_StartSound(mo, sfx_s3k47)
end

function Inazuma.KillEggrobo(mo)
	mo.flags = $ | MF_ENEMY
	P_KillMobj(mo, nil, mo.target)
end

addHook("TouchSpecial", function(bubble, mo)
	if mo.player and Inazuma.IsUltimate(mo.player)
		return true
	end
end, MT_EXTRALARGEBUBBLE)

addHook("TouchSpecial", function(robo, mo)
	local player = mo.player
	
	if not Inazuma.CheckStatus(player)
	or not Inazuma.IsUltimate(player)
	or P_PlayerInPain(player)
	or not robo.valid
	or robo.health <= 0
		return
	end
	
	Inazuma.SmackEggrobo(player, robo)
	return true
end, MT_EGGROBO1)

addHook("MobjMoveBlocked", function(mo)
	if mo.health <= 0
	or not (mo.flags2 & MF2_JUSTATTACKED)
		return
	end
	
	Inazuma.KillEggrobo(mo)
end, MT_SILVERHORN_EGGROBO)

addHook("MobjThinker", function(mo)
	if mo.fuse > 0
	and (mo.fuse & 1) == 0
		A_BossScream(mo)
	end
	
	if mo.health <= 0
	or not (mo.flags2 & MF2_JUSTATTACKED)
		return
	end
	
	mo.rollangle = $ + ANGLE_22h
	mo.angle = $ + ANGLE_22h
	
	if mo.z == mo.floorz
	or mo.z + mo.height == mo.ceilingz
		Inazuma.KillEggrobo(mo)
	end
end, MT_SILVERHORN_EGGROBO)

addHook("MobjDeath", function(mo)
	mo.flags = $ | MF_NOGRAVITY
	mo.momx, mo.momy, mo.momz = 0, 0, 0
	mo.fuse = 12
end, MT_SILVERHORN_EGGROBO)

addHook("MobjFuse", function(mo)
	S_StartSound(mo, sfx_pop)
end, MT_SILVERHORN_EGGROBO)

addHook("MobjSpawn", function(mo)
	A_BossJetFume(mo, 4)
end, MT_SILVERHORN_EGGROBO)

// destroy Inazuma data when players spawn or leave

addHook("PlayerSpawn", Inazuma.DestroyInazumaData)
addHook("PlayerQuit", Inazuma.DestroyInazumaData)
