local othiusHudFade

addHook("LinedefExecute", function(line, mo, sector)
	if (displayplayer and displayplayer.valid and displayplayer.mo == mo)
	or (secondarydisplayplayer and secondarydisplayplayer.valid and secondarydisplayplayer.mo == mo)
		if othiusHudFade == nil
			othiusHudFade = 1
		elseif not othiusHudFade
			othiusHudFade = 10
		end
	end
end, "BLOOPS__HUDFADE_")

--simple, v is the drawer, num is the desired transparency, do a truth check with function before drawing with it!
local function adjustHUDTrans(v, num)
	local theShift = min(10,(v.localTransFlag()>>V_ALPHASHIFT)+num)
	if theShift >= 10
		return false
	end
	return (theShift<<V_ALPHASHIFT)
end

hud.add(function(v,p)
	if othiusHudFade != nil and p != secondarydisplayplayer
		othiusHudFade = max(-20, $-1)
		if othiusHudFade == -20
			othiusHudFade = nil
			return
		end
		
		local modTrans = othiusHudFade
		if modTrans > 0
			modTrans = $*3
		else
			modTrans = abs($)/2
		end
		local hudTrans = adjustHUDTrans(v, modTrans)
		if hudTrans
		or hudTrans == 0
			local patch = v.cachePatch('YOUREWELCOMEOTHIUS')
			v.drawStretched(0, 0, v.width()*FU/patch.width, v.height()*FU/patch.height, patch, V_SNAPTOLEFT|V_SNAPTOTOP|V_NOSCALESTART|V_NOSCALEPATCH|hudTrans)
		end
	end
end, "game")